;==============================
; マクロ定義
;==============================

; タイトルボタンを非表示にする（枠外に移動）
[macro name="hide_title_button"]
  [anim name="start"   left=1000 time=600]
  [anim name="load"    left=1000 time=600]
  [anim name="gallery" left=1000 time=600]
  [anim name="config"  left=1000 time=600]
  [anim name="exit"    left=1000 time=600]
  [wait time=60]
  [wa]
[endmacro]

; タイトルボタンを表示する（枠外から移動）
[macro name="show_title_button"]
  [anim name="start"   left=550 time=1000]
  [anim name="load"    left=550 time=1000]
  [anim name="gallery" left=550 time=1000]
  [anim name="config"  left=550 time=1000]
  [anim name="exit"    left=550 time=1000]
  [wa]
[endmacro]

; 各種メニューボタンを初期化する
[macro name="init_menu_button"]
  ; 各種ボタンの表示
  [button name="role_button" role="skip" graphic="button/skip.png" x=1000 y=0]
  [button name="role_button" role="auto" graphic="button/auto.png" x=1000 y=380]
  [button name="role_button" role="menu" graphic="button/menu.png" x=1000 y=480]
[endmacro]

; 各種メニューボタンを非表示にする
[macro name="hide_menu_button"]
  [anim name="role_button" left=1000 time=0]
  [anim name="role_button" left=1000 time=0]
  [anim name="role_button" left=1000 time=0]
[endmacro]

; 各種メニューボタンを表示する
[macro name="show_menu_button"]
  [anim name="role_button" left=700 time=0]
  [anim name="role_button" left=700 time=0]
  [anim name="role_button" left=700 time=0]
[endmacro]


; メッセージレイヤを初期化する
[macro name="init_message_layer"]
  ; メッセージウィンドウの表示
  [layopt layer=message0 visible=true]
  ; メッセージウィンドウの設定
  [position layer="message0" page=fore frame="frame3.png" left=0 top=310 width=800 height=290]
  ; 文字が表示される領域を調整
  [position layer="message0" page=fore margint="100" marginl="40" marginr="170" marginb="60"]
  ; 名前が表示される文字領域の設定
  [ptext name="chara_name_area" layer="message0" color="white" size=26 x=50 y=355]
  [chara_config ptext="chara_name_area"]
  ; ウィンドウメッセージフレームの設定
  [iscript]
    var msg = this.kag.getMessageOuterLayer();
    var type = TG.config.messageWindowType;
    msg.css("background-image", "url(./data/image/frame" + type + ".png)");
  [endscript]
[endmacro]

; 背景の切り替え
[macro name="change_bg"]
  [hide_menu_button]
  [message_off]
  [bg time=%time|0 method=%method|"crossfade" storage=%storage]
  [show_menu_button]
  [message_on]
[endmacro]

; フェードアウトしてからフェードイン
[macro name="fade_bg"]
  [hide_menu_button]
  [message_off]
  [bg time=%time|0 method=%method|"crossfade" storage=h_4004.jpg]
  [bg time=%time|0 method=%method|"crossfade" storage=%storage]
  [show_menu_button]
  [message_on]
[endmacro]

; ＢＧＭの切り替え
[macro name="change_bgm"]
  [stopbgm]
  [playbgm storage=%storage loop=%loop]
[endmacro]

; 改ページクリック待ち（名前欄消去）
[macro name="pp"]
  [p]
  [iscript]
    ; 名前欄消去
    $("." + this.kag.stat.chara_ptext).html("");
    ; ラベル付け（テキスト + インデックス）
    var label_name = escape(this.kag.stat.current_message_str).replace(/[%\.]/g, '') + "_" + this.kag.getStack("macro").index;
    this.kag.ftag.startTag("label", {
      "label_name" : label_name,
      "nextorder" : "true"
    });
    ; 保持している現在のページ内容をクリア
    this.kag.stat.current_page_str = "";
  [endscript]
[endmacro]


; 呼び出し元へ戻る
[return]