tyrano.plugin.kag.layer = {
  tyrano : null,
  kag : null,
  layer_event : {},
  layer_menu : {},
  layer_free : {},
  map_layer_fore : {},
  map_layer_back : {},
  start_point : {
    x : 0,
    y : 0
  },
  end_point : {
    x : 0,
    y : 0
  },
  /**
   * @return {undefined}
   */
  init : function() {
    var that = this;
    var element = $("<div class='layer layer_event_click' style='z-index:9999;display:none'></div>");
    element.css("width", this.kag.config.scWidth).css("height", this.kag.config.scHeight).css("position", "absolute");
    $("body").click(function() {
      if (that.kag.stat.is_skip == true) {
        /** @type {boolean} */
        that.kag.stat.is_skip = false;
      }
      if (that.kag.stat.is_auto == true) {
        if (that.kag.config.autoClickStop == "true") {
          that.kag.ftag.startTag("autostop", {});
        }
      }
      if (that.kag.stat.is_wait_auto = true) {
        /** @type {boolean} */
        that.kag.stat.is_wait_auto = false;
      }
    });
    element.click(function(dataAndEvents) {
      if (that.kag.stat.is_hide_message == true) {
        that.showMessageLayers();
        return;
      }
      if (that.kag.stat.is_adding_text == true) {
        /** @type {boolean} */
        that.kag.stat.is_click_text = true;
        return;
      }
      if (that.kag.stat.is_click_text == true) {
        return;
      }
      if (that.kag.stat.is_stop == true) {
        return;
      }
      that.kag.ftag.nextOrder();
    });
    element.bind("touchstart", function(types) {
      types.preventDefault();
      var tx = event.changedTouches[0].pageX;
      var ty = event.changedTouches[0].pageY;
      that.start_point.x = tx;
      that.start_point.y = ty;
    });
    element.bind("touchend", function(types) {
      if (that.kag.stat.visible_menu_button == false) {
        return false;
      }
      types.preventDefault();
      var tx = event.changedTouches[0].pageX;
      var ty = event.changedTouches[0].pageY;
      that.end_point.x = tx;
      that.end_point.y = ty;
      /** @type {number} */
      var move_x = that.end_point.x - that.start_point.x;
      /** @type {number} */
      var move_y = that.end_point.y - that.start_point.y;
      if (move_x > 250) {
        console.log("\u53f3\u30b9\u30e9\u30a4\u30c9");
      } else {
        if (move_y > 50) {
          that.kag.ftag.startTag("showmenu", {});
        }
      }
    });
    this.layer_event = element;
    this.appendLayer(this.layer_event);
    var layer_menu = $("<div class='layer layer_menu' style='z-index:100000000;display:none'  align='center'></div>");
    layer_menu.css("width", this.kag.config.scWidth).css("height", this.kag.config.scHeight).css("position", "absolute");
    this.layer_menu = layer_menu;
    this.appendLayer(this.layer_menu);
    var layer_free = $("<div class='layer layer_free' style='z-index:9998;display:none' ></div>");
    layer_free.css("width", this.kag.config.scWidth).css("height", this.kag.config.scHeight).css("position", "absolute");
    this.layer_free = layer_free;
    this.appendLayer(this.layer_free);
  },
  /**
   * @return {?}
   */
  getMenuLayer : function() {
    return this.layer_menu;
  },
  /**
   * @return {?}
   */
  getFreeLayer : function() {
    return this.layer_free;
  },
  /**
   * @param {string} layer_name
   * @return {undefined}
   */
  addLayer : function(layer_name) {
    var layer_obj_fore = $("<div class='layer " + layer_name + "_fore layer_fore'></div>");
    var layer_obj_back = $("<div class='layer " + layer_name + "_back layer_back' style='display:none'></div>");
    if (layer_name.indexOf("message") == -1) {
      layer_obj_fore.addClass("layer_camera");
      layer_obj_back.addClass("layer_camera");
    }
    layer_obj_fore.css("width", this.kag.config.scWidth).css("height", this.kag.config.scHeight).css("position", "absolute");
    layer_obj_back.css("width", this.kag.config.scWidth).css("height", this.kag.config.scHeight).css("position", "absolute");
    this.map_layer_fore[layer_name] = layer_obj_fore;
    this.map_layer_back[layer_name] = layer_obj_back;
    this.map_layer_fore[layer_name].attr("l_visible", "true");
    this.map_layer_back[layer_name].attr("l_visible", "true");
    this.appendLayer(this.map_layer_fore[layer_name]);
    this.appendLayer(this.map_layer_back[layer_name]);
  },
  /**
   * @param {?} $rootElement
   * @return {undefined}
   */
  appendLayer : function($rootElement) {
    $("." + this.kag.define.BASE_DIV_NAME).append($rootElement);
  },
  /**
   * @param {?} image_obj
   * @return {undefined}
   */
  appendImage : function(image_obj) {
    $("." + this.kag.define.BASE_DIV_NAME).append(layer_obj);
  },
  /**
   * @param {string} layer_name
   * @param {string} page
   * @return {?}
   */
  getLayer : function(layer_name, page) {
    if (layer_name == "fix") {
      return $("#tyrano_base");
    }
    page = page || "fore";
    if (page == "fore") {
      return this.map_layer_fore[layer_name];
    } else {
      return this.map_layer_back[layer_name];
    }
  },
  /**
   * @param {?} layer_name
   * @param {string} page
   * @param {?} layer_obj
   * @return {undefined}
   */
  updateLayer : function(layer_name, page, layer_obj) {
    page = page || "fore";
    if (page == "fore") {
      this.map_layer_fore[layer_name] = layer_obj;
    } else {
      this.map_layer_back[layer_name] = layer_obj;
    }
  },
  /**
   * @return {undefined}
   */
  hideMessageLayers : function() {
    /** @type {boolean} */
    this.kag.stat.is_hide_message = true;
    /** @type {number} */
    var numGuis = parseInt(this.kag.config.numMessageLayers);
    /** @type {number} */
    var i = 0;
    for (;i < numGuis;i++) {
      this.getLayer("message" + i).hide();
    }
    this.hideFixLayer();
  },
  /**
   * @return {undefined}
   */
  showMessageLayers : function() {
    /** @type {boolean} */
    this.kag.stat.is_hide_message = false;
    /** @type {number} */
    var numGuis = parseInt(this.kag.config.numMessageLayers);
    /** @type {number} */
    var i = 0;
    for (;i < numGuis;i++) {
      var j_layer = this.getLayer("message" + i);
      if (j_layer.attr("l_visible") == "true") {
        j_layer.show();
      }
    }
    this.showFixLayer();
  },
  /**
   * @return {undefined}
   */
  showFixLayer : function() {
    $(".fixlayer").show();
  },
  /**
   * @return {undefined}
   */
  hideFixLayer : function() {
    $(".fixlayer").hide();
  },
  /**
   * @param {string} layer_name
   * @param {string} page
   * @param {Object} obj
   * @return {undefined}
   */
  appendObj : function(layer_name, page, obj) {
    obj.css("position", "absolute");
    this.getLayer(layer_name, page).append(obj);
  },
  /**
   * @return {undefined}
   */
  refMessageLayer : function() {
    /** @type {number} */
    var num = 0;
    for (;true;) {
      if (this.map_layer_fore["message" + num]) {
        var bar = this.map_layer_fore["message" + num].find(".message_outer");
        var timefloat = this.map_layer_fore["message" + num].find(".message_inner");
        timefloat.css("left", parseInt(bar.css("left")) + 10).css("top", parseInt(bar.css("top")) + 10).css("width", parseInt(bar.css("width")) - 10).css("height", parseInt(bar.css("height")) - 10);
      } else {
        break;
      }
      num++;
    }
  },
  /**
   * @return {?}
   */
  getLayeyHtml : function() {
    var layer_info = {
      map_layer_fore : {},
      map_layer_back : {},
      layer_free : {},
      layer_fix : {}
    };
    for (key in this.map_layer_fore) {
      layer_info["map_layer_fore"][key] = this.map_layer_fore[key].outerHTML();
    }
    for (key in this.map_layer_back) {
      layer_info["map_layer_back"][key] = this.map_layer_back[key].outerHTML();
    }
    layer_info["layer_free"] = this.layer_free.outerHTML();
    /** @type {number} */
    var n = 0;
    $(".fixlayer").each(function() {
      layer_info["layer_fix"][n] = $(this).outerHTML();
      n++;
    });
    return layer_info;
  },
  /**
   * @param {Object} layer
   * @return {undefined}
   */
  setLayerHtml : function(layer) {
    for (key in layer.map_layer_fore) {
      this["map_layer_fore"][key].remove();
      delete this["map_layer_fore"][key];
      this["map_layer_fore"][key] = $(layer["map_layer_fore"][key]);
      this.appendLayer(this["map_layer_fore"][key]);
    }
    for (key in layer.map_layer_back) {
      this["map_layer_back"][key].remove();
      delete this["map_layer_back"][key];
      this["map_layer_back"][key] = $(layer["map_layer_back"][key]);
      this.appendLayer(this["map_layer_back"][key]);
    }
    $(".fixlayer").each(function() {
      $(this).remove();
    });
    for (key in layer.layer_fix) {
      $("#tyrano_base").append($(layer.layer_fix[key]));
    }
    this.layer_free.remove();
    delete this.layer_free;
    this.layer_free = $(layer.layer_free);
    this.appendLayer(this.layer_free);
  },
  /**
   * @return {undefined}
   */
  clearMessageInnerLayerAll : function() {
    for (key in this.map_layer_fore) {
      if (key.indexOf("message") != -1) {
        this.map_layer_fore[key].find(".message_inner").html("");
      }
    }
  },
  /**
   * @param {string} layer
   * @return {undefined}
   */
  backlay : function(layer) {
    layer = layer || "";
    for (key in this.map_layer_fore) {
      if (layer == "" || layer == key) {
        var classes = this.map_layer_fore[key].attr("class");
        var cls = this.map_layer_back[key].attr("class");
        this.map_layer_back[key] = this.map_layer_fore[key].clone();
        this.map_layer_back[key].removeClass(classes);
        this.map_layer_back[key].addClass(cls);
        cls = $.replaceAll(cls, " ", ".");
        $("." + cls).remove();
        this.map_layer_back[key].hide();
        this.appendLayer(this.map_layer_back[key]);
      }
    }
  },
  /**
   * @return {undefined}
   */
  showEventLayer : function() {
    /** @type {boolean} */
    this.kag.stat.is_stop = false;
    this.layer_event.show();
  },
  /**
   * @return {undefined}
   */
  hideEventLayer : function() {
    /** @type {boolean} */
    this.kag.stat.is_stop = true;
    this.layer_event.hide();
  },
  /**
   * @param {string} layer
   * @return {undefined}
   */
  forelay : function(layer) {
    layer = layer || "";
    for (key in this.map_layer_back) {
      if (layer == "" || layer == key) {
        var cls = this.map_layer_fore[key].attr("class");
        var classes = this.map_layer_back[key].attr("class");
        this.map_layer_fore[key] = this.map_layer_back[key].clone(true);
        this.map_layer_fore[key].removeClass(classes);
        this.map_layer_fore[key].addClass(cls);
        cls = $.replaceAll(cls, " ", ".");
        $("." + cls).remove();
        this.appendLayer(this.map_layer_fore[key]);
        this.map_layer_back[key].css("display", "none");
        if (key.indexOf("message") != -1) {
          this.map_layer_fore[key].css("opacity", "");
        }
      }
    }
  },
  /**
   * @return {undefined}
   */
  test : function() {
  }
};
