tyrano.plugin.kag.parser = {
  tyrano : null,
  kag : null,
  flag_script : false,
  /**
   * @return {undefined}
   */
  init : function() {
  },
  /**
   * @param {?} callback
   * @return {undefined}
   */
  loadConfig : function(callback) {
    var that = this;
    $.loadText("./data/system/Config.tjs", function(text_str) {
      var STOP = that.compileConfig(text_str);
      if (callback) {
        callback(STOP);
      }
    });
  },
  /**
   * @param {string} text_str
   * @return {?}
   */
  compileConfig : function(text_str) {
    /** @type {string} */
    var error_str = "";
    var flags = {};
    var codeSegments = text_str.split("\n");
    /** @type {number} */
    var i = 0;
    for (;i < codeSegments.length;i++) {
      try {
        var line_str = $.trim(codeSegments[i]);
        if (line_str != "" && line_str.substr(0, 1) === ";") {
          var splits = line_str.split("//");
          if (splits.length > 1) {
            line_str = $.trim(splits[0]);
          }
          line_str = $.replaceAll(line_str, ";", "");
          line_str = $.replaceAll(line_str, '"', "");
          var coords = line_str.split("=");
          var key = $.trim(coords[0]);
          var value = $.trim(coords[1]);
          flags[key] = value;
        }
      } catch (e) {
        error_str += "Error:Config.tjs\u306b\u8aa4\u308a\u304c\u3042\u308a\u307e\u3059/\u884c:" + i + "";
      }
    }
    if (error_str != "") {
      alert(error_str);
    }
    return flags;
  },
  /**
   * @param {string} text_str
   * @return {?}
   */
  parseScenario : function(text_str) {
    /** @type {Array} */
    var array_s = [];
    var map_label = {};
    var codeSegments = text_str.split("\n");
    /** @type {boolean} */
    var flag_comment = false;
    /** @type {number} */
    var i = 0;
    for (;i < codeSegments.length;i++) {
      var line_str = $.trim(codeSegments[i]);
      var first_char = line_str.substr(0, 1);
      if (line_str.indexOf("endscript") != -1) {
        /** @type {boolean} */
        this.flag_script = false;
      }
      if (flag_comment === true && line_str === "*/") {
        /** @type {boolean} */
        flag_comment = false;
      } else {
        if (line_str === "/*") {
          /** @type {boolean} */
          flag_comment = true;
        } else {
          if (flag_comment == true || first_char === ";") {
          } else {
            if (first_char === "#") {
              var cur = $.trim(line_str.replace("#", ""));
              /** @type {string} */
              var tmp = "";
              /** @type {string} */
              var value = "";
              if (cur.split(":").length > 1) {
                var arr = cur.split(":");
                tmp = arr[0];
                value = arr[1];
              } else {
                tmp = cur;
              }
              var text_obj = {
                line : i,
                name : "chara_ptext",
                pm : {
                  "name" : tmp,
                  "face" : value
                },
                val : val
              };
              array_s.push(text_obj);
            } else {
              if (first_char === "*") {
                var rows = line_str.substr(1, line_str.length).split("|");
                /** @type {string} */
                var label_key = "";
                /** @type {string} */
                var n = "";
                label_key = $.trim(rows[0]);
                if (rows.length > 1) {
                  n = $.trim(rows[1]);
                }
                var label_obj = {
                  name : "label",
                  pm : {
                    "line" : i,
                    "index" : array_s.length,
                    "label_name" : label_key,
                    "val" : n
                  },
                  val : n
                };
                array_s.push(label_obj);
                if (map_label[label_obj.pm.label_name]) {
                  this.kag.warning("Warning line:" + i + " " + $.lang("label") + "'" + label_obj.pm.label_name + "'" + $.lang("label_double"));
                } else {
                  map_label[label_obj.pm.label_name] = label_obj.pm;
                }
              } else {
                if (first_char === "@") {
                  var tag_str = line_str.substr(1, line_str.length);
                  var tmpobj = this.makeTag(tag_str, i);
                  array_s.push(tmpobj);
                } else {
                  if (first_char === "_") {
                    line_str = line_str.substring(1, line_str.length);
                  }
                  var chunks = line_str.split("");
                  /** @type {string} */
                  var val = "";
                  /** @type {string} */
                  tag_str = "";
                  /** @type {boolean} */
                  var flag_tag = false;
                  /** @type {number} */
                  var num_kakko = 0;
                  /** @type {number} */
                  var index = 0;
                  for (;index < chunks.length;index++) {
                    var c = chunks[index];
                    if (flag_tag === true) {
                      if (c === "]" && this.flag_script == false) {
                        num_kakko--;
                        if (num_kakko == 0) {
                          /** @type {boolean} */
                          flag_tag = false;
                          array_s.push(this.makeTag(tag_str, i));
                          /** @type {string} */
                          tag_str = "";
                        } else {
                          tag_str += c;
                        }
                      } else {
                        if (c === "[" && this.flag_script == false) {
                          num_kakko++;
                          tag_str += c;
                        } else {
                          tag_str += c;
                        }
                      }
                    } else {
                      if (flag_tag === false && (c === "[" && this.flag_script == false)) {
                        num_kakko++;
                        if (val != "") {
                          text_obj = {
                            line : i,
                            name : "text",
                            pm : {
                              "val" : val
                            },
                            val : val
                          };
                          array_s.push(text_obj);
                          /** @type {string} */
                          val = "";
                        }
                        /** @type {boolean} */
                        flag_tag = true;
                      } else {
                        val += c;
                      }
                    }
                  }
                  if (val != "") {
                    text_obj = {
                      line : i,
                      name : "text",
                      pm : {
                        "val" : val
                      },
                      val : val
                    };
                    array_s.push(text_obj);
                  }
                }
              }
            }
          }
        }
      }
    }
    var result_obj = {
      array_s : array_s,
      map_label : map_label
    };
    return result_obj;
  },
  /**
   * @param {string} str
   * @param {number} line
   * @return {?}
   */
  makeTag : function(str, line) {
    var obj = {
      line : line,
      name : "",
      pm : {},
      val : ""
    };
    var formats = str.split("");
    /** @type {string} */
    var date = "";
    /** @type {string} */
    var newStr = "";
    /** @type {number} */
    var j = 0;
    for (;j < formats.length;j++) {
      var format = formats[j];
      if (date == "" && (format === '"' || format === "'")) {
        date = format;
      } else {
        if (date != "") {
          if (format === date) {
            /** @type {string} */
            date = "";
          } else {
            if (format == "=") {
              /** @type {string} */
              format = "#";
            }
            if (format == " ") {
              /** @type {string} */
              format = "";
            }
            newStr += format;
          }
        } else {
          newStr += format;
        }
      }
    }
    /** @type {string} */
    str = newStr;
    /** @type {Array.<string>} */
    var array = str.split(" ");
    obj.name = $.trim(array[0]);
    /** @type {number} */
    var k = 1;
    for (;k < array.length;k++) {
      if (array[k] == "") {
        array.splice(k, 1);
        k--;
      } else {
        if (array[k] === "=") {
          if (array[k - 1]) {
            if (array[k + 1]) {
              /** @type {string} */
              array[k - 1] = array[k - 1] + "=" + array[k + 1];
              array.splice(k, 2);
              k--;
            }
          }
        } else {
          if (array[k].substr(0, 1) === "=") {
            if (array[k - 1]) {
              if (array[k]) {
                /** @type {string} */
                array[k - 1] = array[k - 1] + array[k];
                array.splice(k, 1);
              }
            }
          } else {
            if (array[k].substr(array[k].length - 1, array[k].length) === "=") {
              if (array[k + 1]) {
                if (array[k]) {
                  /** @type {string} */
                  array[k] = array[k] + array[k + 1];
                  array.splice(k + 1, 1);
                }
              }
            }
          }
        }
      }
    }
    /** @type {number} */
    var i = 1;
    for (;i < array.length;i++) {
      var coords = $.trim(array[i]).split("=");
      var pm_key = $.trim(coords[0]);
      var pm_val = $.trim(coords[1]);
      var pmobj = {};
      pmobj[pm_key] = pm_val;
      obj.pm[pm_key] = $.replaceAll(pm_val, "#", "=");
    }
    if (obj.name == "iscript") {
      /** @type {boolean} */
      this.flag_script = true;
    }
    if (obj.name == "endscript") {
      /** @type {boolean} */
      this.flag_script = false;
    }
    return obj;
  },
  /**
   * @return {undefined}
   */
  test : function() {
  }
};
