tyrano.plugin.kag.ftag = {
  tyrano : null,
  kag : null,
  array_tag : [],
  master_tag : {},
  current_order_index : -1,
  /**
   * @return {undefined}
   */
  init : function() {
    var order_type;
    for (order_type in tyrano.plugin.kag.tag) {
      this.master_tag[order_type] = object(tyrano.plugin.kag.tag[order_type]);
      this.master_tag[order_type].kag = this.kag;
    }
  },
  /**
   * @param {?} deepDataAndEvents
   * @param {string} hash
   * @return {undefined}
   */
  buildTag : function(deepDataAndEvents, hash) {
    this.array_tag = deepDataAndEvents;
    if (hash) {
      this.nextOrderWithLabel(hash);
    } else {
      this.nextOrderWithLabel("");
    }
  },
  /**
   * @param {?} dataAndEvents
   * @param {number} triggerRoute
   * @param {string} deepDataAndEvents
   * @return {undefined}
   */
  buildTagIndex : function(dataAndEvents, triggerRoute, deepDataAndEvents) {
    this.array_tag = dataAndEvents;
    this.nextOrderWithIndex(triggerRoute, undefined, undefined, undefined, deepDataAndEvents);
  },
  /**
   * @return {undefined}
   */
  completeTrans : function() {
    if (this.kag.stat.is_stop == true) {
      this.kag.layer.showEventLayer();
      this.nextOrder();
    }
  },
  /**
   * @return {undefined}
   */
  hideNextImg : function() {
    $(".img_next").remove();
    $(".glyph_image").hide();
  },
  /**
   * @return {?}
   */
  nextOrder : function() {
    this.kag.layer.layer_event.hide();
    var that = this;
    if (this.kag.stat.is_strong_stop == true) {
      return false;
    }
    try {
      this.current_order_index++;
      if (this.array_tag.length <= this.current_order_index) {
        this.kag.endStorage();
        return false;
      }
      var self = $.cloneObject(this.array_tag[this.current_order_index]);
      this.kag.stat.current_line = self.line;
      if (this.kag.is_rider) {
        self.ks_file = this.kag.stat.current_scenario;
        this.kag.rider.pushConsoleLog(self);
      } else {
        this.kag.log("**:" + this.current_order_index + "\u3000line:" + self.line);
        this.kag.log(self);
      }
      if (self.name == "call" && self.pm.storage == "make.ks" || this.kag.stat.current_scenario == "make.ks") {
      } else {
        if (this.kag.stat.flag_ref_page == true) {
          /** @type {boolean} */
          this.kag.stat.flag_ref_page = false;
          this.kag.ftag.hideNextImg();
          this.kag.getMessageInnerLayer().html("");
        }
      }
      if (this.checkCond(self) != true) {
        this.nextOrder();
        return;
      }
      if (this.kag.stat.is_hide_message == true) {
        this.kag.layer.showMessageLayers();
        /** @type {boolean} */
        this.kag.stat.is_hide_message = false;
      }
      if (this.master_tag[self.name]) {
        self.pm = this.convertEntity(self.pm);
        var output = this.checkVital(self);
        if (this.checkCw(self)) {
          this.kag.layer.layer_event.show();
        }
        if (output != "") {
          this.kag.error(output);
        } else {
          this.master_tag[self.name].start($.extend(true, $.cloneObject(this.master_tag[self.name].pm), self.pm));
        }
      } else {
        if (this.kag.stat.map_macro[self.name]) {
          self.pm = this.convertEntity(self.pm);
          var len = self.pm;
          var pm = this.kag.stat.map_macro[self.name];
          var options = {};
          options.index = this.kag.ftag.current_order_index;
          options.storage = this.kag.stat.current_scenario;
          options.pm = len;
          this.kag.stat.mp = len;
          this.kag.pushStack("macro", options);
          this.kag.ftag.nextOrderWithIndex(pm.index, pm.storage);
        } else {
          $.error_message($.lang("tag") + "\uff1a[" + self.name + "]" + $.lang("not_exists"));
          this.nextOrder();
        }
      }
    } catch (fmt) {
      console.log(fmt);
      that.kag.error($.lang("error_occurred"));
    }
  },
  /**
   * @param {Function} fun
   * @return {?}
   */
  checkCw : function(fun) {
    var global = this.master_tag[fun.name];
    if (global.cw) {
      if (this.kag.stat.is_script != true && (this.kag.stat.is_html != true && this.kag.stat.checking_macro != true)) {
        return true;
      } else {
        return false;
      }
    } else {
      return false;
    }
  },
  /**
   * @param {Object} items
   * @return {?}
   */
  nextOrderWithTag : function(items) {
    try {
      this.current_order_index++;
      var self = this.array_tag[this.current_order_index];
      if (this.checkCond(self) != true) {
      }
      if (items[self.name] == "") {
        if (this.master_tag[self.name]) {
          self.pm = this.convertEntity(self.pm);
          this.master_tag[self.name].start($.extend(true, $.cloneObject(this.master_tag[self.name].pm), self.pm));
          return true;
        } else {
          return false;
        }
      } else {
        return false;
      }
    } catch (e) {
      console.log(this.array_tag);
      return false;
    }
  },
  /**
   * @param {Object} data
   * @return {?}
   */
  convertEntity : function(data) {
    var that = this;
    if (data["*"] == "") {
      data = $.extend(true, $.cloneObject(data), this.kag.stat.mp);
    }
    for (key in data) {
      var v = data[key];
      /** @type {string} */
      var optsData = "";
      if (v.length > 0) {
        optsData = v.substr(0, 1);
      }
      if (v.length > 0 && optsData === "&") {
        data[key] = this.kag.embScript(v.substr(1, v.length));
      } else {
        if (v.length > 0 && optsData === "%") {
          var l10n = this.kag.getStack("macro");
          if (l10n) {
            data[key] = l10n.pm[v.substr(1, v.length)];
          }
          var rows = v.split("|");
          if (rows.length == 2) {
            if (l10n.pm[$.trim(rows[0]).substr(1, $.trim(rows[0]).length)]) {
              data[key] = l10n.pm[$.trim(rows[0]).substr(1, $.trim(rows[0]).length)];
            } else {
              data[key] = $.trim(rows[1]);
            }
          }
        }
      }
    }
    return data;
  },
  /**
   * @param {Function} obj
   * @return {?}
   */
  checkVital : function(obj) {
    var master_tag = this.master_tag[obj.name];
    /** @type {string} */
    var optsData = "";
    if (master_tag.vital) {
    } else {
      return "";
    }
    var codeSegments = master_tag.vital;
    /** @type {number} */
    var i = 0;
    for (;i < codeSegments.length;i++) {
      if (obj.pm[codeSegments[i]]) {
        if (obj.pm[codeSegments[i]] == "") {
          optsData += "\u30bf\u30b0\u300c" + obj.name + "\u300d\u306b\u30d1\u30e9\u30e1\u30fc\u30bf\u30fc\u300c" + codeSegments[i] + "\u300d\u306f\u5fc5\u9808\u3067\u3059\u3000\n";
        }
      } else {
        optsData += "\u30bf\u30b0\u300c" + obj.name + "\u300d\u306b\u30d1\u30e9\u30e1\u30fc\u30bf\u30fc\u300c" + codeSegments[i] + "\u300d\u306f\u5fc5\u9808\u3067\u3059\u3000\n";
      }
    }
    return optsData;
  },
  /**
   * @param {?} self
   * @return {?}
   */
  checkCond : function(self) {
    var params = self.pm;
    if (params.cond) {
      var cond = params.cond;
      return this.kag.embScript(cond);
    } else {
      return true;
    }
  },
  /**
   * @param {string} name
   * @param {?} replacementHash
   * @return {undefined}
   */
  startTag : function(name, replacementHash) {
    this.master_tag[name].start($.extend(true, $.cloneObject(this.master_tag[name].pm), replacementHash));
  },
  /**
   * @param {string} hash
   * @param {string} regex
   * @return {undefined}
   */
  nextOrderWithLabel : function(hash, regex) {
    /** @type {boolean} */
    this.kag.stat.is_strong_stop = false;
    if (hash) {
      if (hash.indexOf("*") != -1) {
        hash = hash.substr(1, hash.length);
      }
      this.kag.ftag.startTag("label", {
        "label_name" : hash,
        "nextorder" : "false"
      });
    }
    if (hash == "*savesnap") {
      var data = this.kag.menu.snap;
      var triggerRoute = data.current_order_index;
      var typePattern = data.stat.current_scenario;
      this.nextOrderWithIndex(triggerRoute, typePattern, undefined, undefined, "snap");
      return;
    }
    var that = this;
    /** @type {string} */
    var queryString = regex;
    hash = hash || "";
    regex = regex || this.kag.stat.current_scenario;
    hash = hash.replace("*", "");
    if (regex != this.kag.stat.current_scenario && queryString != null) {
      this.kag.layer.hideEventLayer();
      this.kag.loadScenario(regex, function(deepDataAndEvents) {
        that.kag.layer.showEventLayer();
        that.kag.ftag.buildTag(deepDataAndEvents, hash);
      });
      return;
    }
    if (hash == "") {
      /** @type {number} */
      this.current_order_index = -1;
      this.nextOrder();
    } else {
      if (this.kag.stat.map_label[hash]) {
        var cell = this.kag.stat.map_label[hash];
        this.current_order_index = cell.index;
        this.nextOrder();
      } else {
        $.error_message($.lang("label") + "\uff1a'" + hash + "'" + $.lang("not_exists"));
        this.nextOrder();
      }
    }
  },
  /**
   * @param {number} triggerRoute
   * @param {string} args
   * @param {boolean} data
   * @param {?} options
   * @param {string} deepDataAndEvents
   * @return {undefined}
   */
  nextOrderWithIndex : function(triggerRoute, args, data, options, deepDataAndEvents) {
    /** @type {boolean} */
    this.kag.stat.is_strong_stop = false;
    this.kag.layer.showEventLayer();
    var that = this;
    data = data || false;
    deepDataAndEvents = deepDataAndEvents || "yes";
    args = args || this.kag.stat.current_scenario;
    if (args != this.kag.stat.current_scenario || data == true) {
      this.kag.layer.hideEventLayer();
      this.kag.loadScenario(args, function(node) {
        if (typeof options == "object") {
          node.splice(triggerRoute + 1, 0, options);
        }
        that.kag.layer.showEventLayer();
        that.kag.ftag.buildTagIndex(node, triggerRoute, deepDataAndEvents);
      });
      return;
    }
    /** @type {number} */
    this.current_order_index = triggerRoute;
    if (deepDataAndEvents == "yes") {
      this.nextOrder();
    } else {
      if (deepDataAndEvents == "snap") {
        this.kag.stat.is_strong_stop = this.kag.menu.snap.stat.is_strong_stop;
        if (this.kag.stat.is_skip == true && this.kag.stat.is_strong_stop == false) {
          this.kag.ftag.nextOrder();
        }
      } else {
        if (deepDataAndEvents == "stop") {
          this.kag.ftag.startTag("s", {
            "val" : {}
          });
        }
      }
    }
  }
};
tyrano.plugin.kag.tag.text = {
  cw : true,
  pm : {
    "val" : ""
  },
  /**
   * @param {Text} ui
   * @return {undefined}
   */
  start : function(ui) {
    if (this.kag.stat.is_script == true) {
      this.kag.stat.buff_script += ui.val + "\n";
      this.kag.ftag.nextOrder();
      return;
    }
    if (this.kag.stat.is_html == true) {
      this.kag.stat.map_html.buff_html += ui.val;
      this.kag.ftag.nextOrder();
      return;
    }
    var $el = this.kag.getMessageInnerLayer();
    $el.css({
      "letter-spacing" : this.kag.config.defaultPitch + "px",
      "line-height" : parseInt(this.kag.config.defaultFontSize) + parseInt(this.kag.config.defaultLineSpacing) + "px",
      "font-family" : this.kag.config.userFace
    });
    this.kag.stat.current_message_str = ui.val;
    this.kag.stat.current_page_str = this.kag.stat.current_page_str + ui.val;
    if (this.kag.stat.vertical == "true") {
      if (this.kag.config.defaultAutoReturn != "false") {
        var bar = this.kag.getMessageOuterLayer();
        /** @type {number} */
        var b = parseInt(bar.css("width")) * 0.8;
        /** @type {number} */
        var a = parseInt($el.find("p").css("width"));
        if (a > b) {
          this.kag.getMessageInnerLayer().html("");
        }
      }
      this.showMessageVertical(ui.val);
    } else {
      if (this.kag.config.defaultAutoReturn != "false") {
        bar = this.kag.getMessageOuterLayer();
        /** @type {number} */
        var s = parseInt(bar.css("height")) * 0.8;
        /** @type {number} */
        var ms = parseInt($el.find("p").css("height"));
        if (ms > s) {
          this.kag.getMessageInnerLayer().html("");
        }
      }
      this.showMessage(ui.val);
    }
  },
  /**
   * @param {Object} message
   * @return {undefined}
   */
  showMessage : function(message) {
    var that = this;
    var substring = $.isNull($(".chara_name_area").html());
    if (substring != "") {
      this.kag.pushBackLog("<b>" + substring + "</b>\uff1a" + message);
    } else {
      this.kag.pushBackLog(message);
    }
    that.kag.ftag.hideNextImg();
    (function($rootElement) {
      if ($rootElement.html() == "") {
        $rootElement.append("<p class=''></p>");
      }
      /** @type {Object} */
      var moduleNamePlusExt = message;
      /** @type {string} */
      var parsedAnchor = "";
      if ($rootElement.find("p").find(".current_span").length != 0) {
        parsedAnchor = $rootElement.find("p").find(".current_span").html();
      }
      /** @type {number} */
      var index = 0;
      that.kag.checkMessage($rootElement);
      var text = that.kag.getMessageCurrentSpan();
      text.css({
        "color" : that.kag.stat.font.color,
        "font-weight" : that.kag.stat.font.bold,
        "font-size" : that.kag.stat.font.size + "px",
        "font-family" : that.kag.stat.font.face,
        "font-style" : that.kag.stat.font.italic
      });
      /** @type {number} */
      var wait = 30;
      if (that.kag.stat.ch_speed != "") {
        /** @type {number} */
        wait = parseInt(that.kag.stat.ch_speed);
      } else {
        if (that.kag.config.chSpeed) {
          /** @type {number} */
          wait = parseInt(that.kag.config.chSpeed);
        }
      }
      if (that.kag.config.autoRecordLabel == "true") {
        if (that.kag.stat.already_read == true) {
          if (that.kag.config.alreadyReadTextColor != "default") {
            text.css("color", $.convertColor(that.kag.config.alreadyReadTextColor));
          }
          wait = parseInt(that.kag.config.alreadySpeed);
        } else {
          if (that.kag.config.unReadTextSkip == "false") {
            /** @type {boolean} */
            that.kag.stat.is_skip = false;
          }
        }
      }
      /**
       * @param {Function} fn
       * @return {undefined}
       */
      var init = function(fn) {
        var c = moduleNamePlusExt.substring(index, ++index);
        if (that.kag.stat.ruby_str != "") {
          /** @type {string} */
          c = "<ruby><rb>" + c + "</rb><rt>" + that.kag.stat.ruby_str + "</rt></ruby>";
          /** @type {string} */
          that.kag.stat.ruby_str = "";
        }
        parsedAnchor += c;
        if (that.kag.stat.is_skip != true && that.kag.stat.is_nowait != true) {
          that.kag.appendMessage($rootElement, parsedAnchor);
        }
        if (index <= moduleNamePlusExt.length) {
          /** @type {boolean} */
          that.kag.stat.is_adding_text = true;
          if (that.kag.stat.is_click_text == true || (that.kag.stat.is_skip == true || that.kag.stat.is_nowait == true)) {
            setTimeout(function() {
              fn(fn);
            }, 0);
          } else {
            setTimeout(function() {
              fn(fn);
            }, wait);
          }
        } else {
          /** @type {boolean} */
          that.kag.stat.is_adding_text = false;
          /** @type {boolean} */
          that.kag.stat.is_click_text = false;
          if (that.kag.stat.is_stop != "true") {
            if (that.kag.stat.is_skip == true || that.kag.stat.is_nowait == true) {
              that.kag.appendMessage($rootElement, parsedAnchor);
              setTimeout(function() {
                if (!that.kag.stat.is_hide_message) {
                  that.kag.ftag.nextOrder();
                }
              }, parseInt(that.kag.config.skipSpeed));
            } else {
              if (!that.kag.stat.is_hide_message) {
                that.kag.ftag.nextOrder();
              }
            }
          } else {
          }
          if (that.kag.stat.flag_glyph == "false") {
            $(".img_next").remove();
            $rootElement.find("p").append("<img class='img_next' src='./tyrano/images/kag/nextpage.gif' />");
          } else {
            $(".glyph_image").show();
          }
        }
      };
      init(init);
    })(this.kag.getMessageInnerLayer());
  },
  /**
   * @param {Object} deepDataAndEvents
   * @return {undefined}
   */
  showMessageVertical : function(deepDataAndEvents) {
    var that = this;
    that.kag.ftag.hideNextImg();
    this.kag.pushBackLog(deepDataAndEvents);
    (function($rootElement) {
      if ($rootElement.html() == "") {
        $rootElement.append("<p class='vertical_text'></p>");
      }
      /** @type {Object} */
      var moduleNamePlusExt = deepDataAndEvents;
      /** @type {string} */
      var parsedAnchor = "";
      if ($rootElement.find("p").find(".current_span").length != 0) {
        parsedAnchor = $rootElement.find("p").find(".current_span").html();
      }
      /** @type {number} */
      var index = 0;
      that.kag.checkMessage($rootElement);
      var $details = that.kag.getMessageCurrentSpan();
      $details.css("color", that.kag.stat.font.color).css("font-weight", that.kag.stat.font.bold).css("font-size", that.kag.stat.font.size + "px").css("font-family", that.kag.stat.font.face);
      if (that.kag.config.autoRecordLabel == "true") {
        if (that.kag.config.alreadyReadTextColor != "default") {
          if (that.kag.stat.already_read == true) {
            $details.css("color", $.convertColor(that.kag.config.alreadyReadTextColor));
          }
        }
      }
      /** @type {number} */
      var wait = 30;
      if (that.kag.stat.ch_speed != "") {
        /** @type {number} */
        wait = parseInt(that.kag.stat.ch_speed);
      } else {
        if (that.kag.config.chSpeed) {
          /** @type {number} */
          wait = parseInt(that.kag.config.chSpeed);
        }
      }
      /**
       * @param {Function} fn
       * @return {undefined}
       */
      var init = function(fn) {
        var c = moduleNamePlusExt.substring(index, ++index);
        if (that.kag.stat.ruby_str != "") {
          /** @type {string} */
          c = "<ruby><rb>" + c + "</rb><rt>" + that.kag.stat.ruby_str + "</rt></ruby>";
          /** @type {string} */
          that.kag.stat.ruby_str = "";
        }
        parsedAnchor += c;
        if (that.kag.stat.is_skip != true && that.kag.stat.is_nowait != true) {
          that.kag.appendMessage($rootElement, parsedAnchor);
        }
        if (index <= moduleNamePlusExt.length) {
          /** @type {boolean} */
          that.kag.stat.is_adding_text = true;
          if (that.kag.stat.is_click_text == true || that.kag.stat.is_skip == true) {
            setTimeout(function() {
              fn(fn);
            }, 0);
          } else {
            setTimeout(function() {
              fn(fn);
            }, wait);
          }
        } else {
          /** @type {boolean} */
          that.kag.stat.is_adding_text = false;
          /** @type {boolean} */
          that.kag.stat.is_click_text = false;
          if (that.kag.stat.is_skip == true || that.kag.stat.is_nowait == true) {
            that.kag.appendMessage($rootElement, parsedAnchor);
            setTimeout(function() {
              that.kag.ftag.nextOrder();
            }, parseInt(that.kag.config.skipSpeed));
          } else {
            that.kag.ftag.nextOrder();
          }
          if (that.kag.stat.flag_glyph == "false") {
            $(".img_next").remove();
            $rootElement.find("p").append("<img class='img_next' src='./tyrano/images/kag/nextpage.gif' />");
          } else {
            $(".glyph_image").show();
          }
        }
      };
      init(init);
    })(this.kag.getMessageInnerLayer());
  },
  /**
   * @return {undefined}
   */
  nextOrder : function() {
  },
  /**
   * @return {undefined}
   */
  test : function() {
  }
};
tyrano.plugin.kag.tag.label = {
  pm : {
    nextorder : "true"
  },
  /**
   * @param {?} element
   * @return {undefined}
   */
  start : function(element) {
    if (this.kag.config.autoRecordLabel == "true") {
      var namespace = "trail_" + this.kag.stat.current_scenario.replace(".ks", "").replace(/\u002f/g, "").replace(/:/g, "").replace(/\./g, "");
      var type = this.kag.stat.buff_label_name;
      /** @type {string} */
      var i = namespace + "_" + element.label_name;
      if (this.kag.stat.buff_label_name != "") {
        if (!this.kag.variable.sf.record) {
          this.kag.variable.sf.record = {};
        }
        /** @type {string} */
        var msg = "sf.record." + type;
        /** @type {string} */
        var storage_url = "" + msg + " = " + msg + "  || 0;" + msg + "++;";
        this.kag.evalScript(storage_url);
      }
      if (this.kag.variable.sf.record) {
        if (this.kag.variable.sf.record[i]) {
          /** @type {boolean} */
          this.kag.stat.already_read = true;
        } else {
          /** @type {boolean} */
          this.kag.stat.already_read = false;
        }
      }
      /** @type {string} */
      this.kag.stat.buff_label_name = i;
    }
    if (element.nextorder == "true") {
      this.kag.ftag.nextOrder();
    }
  }
};
tyrano.plugin.kag.tag.config_record_label = {
  pm : {
    color : "",
    skip : ""
  },
  /**
   * @param {Object} args
   * @return {undefined}
   */
  start : function(args) {
    var that = this;
    if (args.color != "") {
      this.kag.config.alreadyReadTextColor = args.color;
      this.kag.ftag.startTag("eval", {
        "exp" : "sf._system_config_already_read_text_color = " + args.color
      });
    }
    if (args.skip !== "") {
      this.kag.config.unReadTextSkip = args.skip;
      this.kag.ftag.startTag("eval", {
        "exp" : "sf._system_config_unread_text_skip = " + args.skip
      });
    }
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.l = {
  cw : true,
  /**
   * @return {undefined}
   */
  start : function() {
    var that = this;
    if (this.kag.stat.is_skip == true) {
      this.kag.ftag.nextOrder();
    } else {
      if (this.kag.stat.is_auto == true) {
        /** @type {boolean} */
        this.kag.stat.is_wait_auto = true;
        setTimeout(function() {
          if (that.kag.stat.is_wait_auto == true) {
            that.kag.ftag.nextOrder();
          }
        }, parseInt(that.kag.config.autoSpeed));
      }
    }
  }
};
tyrano.plugin.kag.tag.p = {
  cw : true,
  /**
   * @return {undefined}
   */
  start : function() {
    var that = this;
    /** @type {boolean} */
    this.kag.stat.flag_ref_page = true;
    if (this.kag.stat.is_skip == true) {
      this.kag.ftag.nextOrder();
    } else {
      if (this.kag.stat.is_auto == true) {
        /** @type {boolean} */
        this.kag.stat.is_wait_auto = true;
        setTimeout(function() {
          if (that.kag.stat.is_wait_auto == true) {
            that.kag.ftag.nextOrder();
          }
        }, parseInt(that.kag.config.autoSpeed));
      }
    }
  }
};
tyrano.plugin.kag.tag.graph = {
  vital : ["storage"],
  pm : {
    storage : null
  },
  /**
   * @param {Object} pm
   * @return {undefined}
   */
  start : function(pm) {
    var wrap = this.kag.getMessageInnerLayer();
    /** @type {string} */
    var optsData = "";
    if (wrap.find("p").find(".current_span").length != 0) {
      optsData = wrap.find("p").find(".current_span").html();
    }
    /** @type {string} */
    var storage_url = "";
    if ($.isHTTP(pm.storage)) {
      storage_url = pm.storage;
    } else {
      /** @type {string} */
      storage_url = "./data/image/" + pm.storage;
    }
    this.kag.appendMessage(wrap, optsData + "<img src='" + storage_url + "' >");
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.jump = {
  pm : {
    storage : null,
    target : null,
    countpage : true
  },
  /**
   * @param {Object} pm
   * @return {undefined}
   */
  start : function(pm) {
    this.kag.ftag.nextOrderWithLabel(pm.target, pm.storage);
  }
};
tyrano.plugin.kag.tag.r = {
  /**
   * @return {undefined}
   */
  start : function() {
    var cmp = this.kag.getMessageInnerLayer();
    var distanceToUserValue = cmp.find("p").find(".current_span").html() + "<br />";
    cmp.find("p").find(".current_span").html(distanceToUserValue);
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.er = {
  /**
   * @return {undefined}
   */
  start : function() {
    this.kag.ftag.hideNextImg();
    this.kag.getMessageInnerLayer().html("");
    this.kag.ftag.startTag("resetfont");
  }
};
tyrano.plugin.kag.tag.cm = {
  /**
   * @return {undefined}
   */
  start : function() {
    this.kag.ftag.hideNextImg();
    this.kag.layer.clearMessageInnerLayerAll();
    this.kag.layer.getFreeLayer().html("").hide();
    this.kag.ftag.startTag("resetfont");
  }
};
tyrano.plugin.kag.tag.ct = {
  /**
   * @return {undefined}
   */
  start : function() {
    this.kag.ftag.hideNextImg();
    this.kag.layer.clearMessageInnerLayerAll();
    this.kag.layer.getFreeLayer().html("").hide();
    /** @type {string} */
    this.kag.stat.current_layer = "message0";
    /** @type {string} */
    this.kag.stat.current_page = "fore";
    this.kag.ftag.startTag("resetfont");
  }
};
tyrano.plugin.kag.tag.current = {
  pm : {
    layer : "",
    page : "fore"
  },
  /**
   * @param {Object} event
   * @return {undefined}
   */
  start : function(event) {
    if (event.layer == "") {
      event.layer = this.kag.stat.current_layer;
    }
    this.kag.stat.current_layer = event.layer;
    this.kag.stat.current_page = event.page;
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.position = {
  pm : {
    layer : "message0",
    page : "fore",
    left : "",
    top : "",
    width : "",
    height : "",
    color : "",
    opacity : "",
    vertical : "",
    frame : "",
    marginl : "0",
    margint : "0",
    marginr : "0",
    marginb : "0"
  },
  /**
   * @param {Object} pm
   * @return {undefined}
   */
  start : function(pm) {
    var div = this.kag.layer.getLayer(pm.layer, pm.page).find(".message_outer");
    var css = {
      left : pm.left + "px",
      top : pm.top + "px",
      width : pm.width + "px",
      height : pm.height + "px",
      "background-color" : $.convertColor(pm.color)
    };
    if (pm.vertical != "") {
      if (pm.vertical == "true") {
        /** @type {string} */
        this.kag.stat.vertical = "true";
      } else {
        /** @type {string} */
        this.kag.stat.vertical = "false";
      }
    }
    if (pm.frame == "none") {
      div.css("opacity", $.convertOpacity(this.kag.config.frameOpacity));
      div.css("background-image", "");
      div.css("background-color", $.convertColor(this.kag.config.frameColor));
    } else {
      if (pm.frame != "") {
        /** @type {string} */
        var frame = "";
        if ($.isHTTP(pm.frame)) {
          frame = pm.frame;
        } else {
          /** @type {string} */
          frame = "./data/image/" + pm.frame + "";
        }
        div.css("background-image", "url(" + frame + ")");
        div.css("background-repeat", "no-repeat");
        div.css("opacity", 1);
        div.css("background-color", "");
      }
    }
    if (pm.opacity != "") {
      div.css("opacity", $.convertOpacity(pm.opacity));
    }
    this.kag.setStyles(div, css);
    this.kag.layer.refMessageLayer();
    var wrapper = this.kag.layer.getLayer(pm.layer, pm.page).find(".message_inner");
    var style = {};
    if (pm.marginl != "0") {
      /** @type {string} */
      style["padding-left"] = parseInt(pm.marginl) + "px";
    }
    if (pm.margint != "0") {
      /** @type {string} */
      style["padding-top"] = parseInt(pm.margint) + "px";
    }
    if (pm.marginr != "0") {
      /** @type {string} */
      style["width"] = parseInt(wrapper.css("width")) - parseInt(pm.marginr) + "px";
    }
    if (pm.marginb != "0") {
      /** @type {string} */
      style["height"] = parseInt(wrapper.css("height")) - parseInt(pm.marginb) + "px";
    }
    this.kag.setStyles(wrapper, style);
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.image = {
  pm : {
    "layer" : "base",
    "page" : "fore",
    "visible" : "",
    "top" : "",
    "left" : "",
    "x" : "",
    "y" : "",
    "width" : "",
    "height" : "",
    "pos" : "",
    "name" : "",
    "folder" : "",
    "time" : ""
  },
  /**
   * @param {Object} options
   * @return {undefined}
   */
  start : function(options) {
    /** @type {string} */
    var storage_url = "";
    /** @type {string} */
    var language = "";
    var that = this;
    if (options.layer != "base") {
      var style = {};
      if (options.visible == "true" && options.page == "fore") {
        /** @type {string} */
        style.display = "block";
      }
      this.kag.setStyles(this.kag.layer.getLayer(options.layer, options.page), style);
      if (options.pos != "") {
        switch(options.pos) {
          case "left":
          ;
          case "l":
            options.left = this.kag.config["scPositionX.left"];
            break;
          case "left_center":
          ;
          case "lc":
            options.left = this.kag.config["scPositionX.left_center"];
            break;
          case "center":
          ;
          case "c":
            options.left = this.kag.config["scPositionX.center"];
            break;
          case "right_center":
          ;
          case "rc":
            options.left = this.kag.config["scPositionX.right_center"];
            break;
          case "right":
          ;
          case "r":
            options.left = this.kag.config["scPositionX.right"];
            break;
        }
      }
      if (options.folder != "") {
        language = options.folder;
      } else {
        /** @type {string} */
        language = "fgimage";
      }
      if ($.isHTTP(options.storage)) {
        storage_url = options.storage;
      } else {
        /** @type {string} */
        storage_url = "./data/" + language + "/" + options.storage;
      }
      var img_obj = $("<img />");
      img_obj.attr("src", storage_url);
      img_obj.css("position", "absolute");
      img_obj.css("top", options.top + "px");
      img_obj.css("left", options.left + "px");
      if (options.width != "") {
        img_obj.css("width", options.width + "px");
      }
      if (options.height != "") {
        img_obj.css("height", options.height + "px");
      }
      if (options.x != "") {
        img_obj.css("left", options.x + "px");
      }
      if (options.y != "") {
        img_obj.css("top", options.y + "px");
      }
      $.setName(img_obj, options.name);
      if (options.time == 0) {
        /** @type {string} */
        options.time = "";
      }
      if (options.time != "") {
        img_obj.css("opacity", 0);
        this.kag.layer.getLayer(options.layer, options.page).append(img_obj);
        img_obj.animate({
          "opacity" : 1
        }, parseInt(options.time), function() {
          that.kag.ftag.nextOrder();
        });
      } else {
        this.kag.layer.getLayer(options.layer, options.page).append(img_obj);
        this.kag.ftag.nextOrder();
      }
    } else {
      if (options.folder != "") {
        language = options.folder;
      } else {
        /** @type {string} */
        language = "bgimage";
      }
      if ($.isHTTP(options.storage)) {
        storage_url = options.storage;
      } else {
        /** @type {string} */
        storage_url = "./data/" + language + "/" + options.storage;
      }
      var css = {
        "background-image" : "url(" + storage_url + ")",
        "display" : "none"
      };
      if (options.page === "fore") {
        /** @type {string} */
        css.display = "block";
      }
      this.kag.setStyles(this.kag.layer.getLayer(options.layer, options.page), css);
      this.kag.ftag.nextOrder();
    }
  }
};
tyrano.plugin.kag.tag.freeimage = {
  vital : ["layer"],
  pm : {
    layer : "",
    page : "fore",
    time : ""
  },
  /**
   * @param {Object} d
   * @return {undefined}
   */
  start : function(d) {
    var that = this;
    if (d.layer != "base") {
      if (d.time == 0) {
        /** @type {string} */
        d.time = "";
      }
      if (d.time != "") {
        var img = this.kag.layer.getLayer(d.layer, d.page).children();
        /** @type {number} */
        var name = 0;
        var m = img.length;
        img.animate({
          "opacity" : 0
        }, parseInt(d.time), function() {
          that.kag.layer.getLayer(d.layer, d.page).empty();
          name++;
          if (m == name) {
            that.kag.ftag.nextOrder();
          }
        });
      } else {
        that.kag.layer.getLayer(d.layer, d.page).empty();
        that.kag.ftag.nextOrder();
      }
    } else {
      this.kag.layer.getLayer(d.layer, d.page).css("background-image", "");
      this.kag.ftag.nextOrder();
    }
  }
};
tyrano.plugin.kag.tag.freelayer = tyrano.plugin.kag.tag.freeimage;
tyrano.plugin.kag.tag.free = {
  vital : ["layer", "name"],
  pm : {
    layer : "",
    page : "fore",
    name : "",
    wait : "true",
    time : ""
  },
  /**
   * @param {Object} pm
   * @return {undefined}
   */
  start : function(pm) {
    var that = this;
    if (pm.layer != "base") {
      if (pm.time == 0) {
        /** @type {string} */
        pm.time = "";
      }
      if (pm.time != "") {
        var img = this.kag.layer.getLayer(pm.layer, pm.page);
        img = img.find("." + pm.name);
        /** @type {number} */
        var ms = 0;
        var m = img.length;
        img.animate({
          "opacity" : 0
        }, parseInt(pm.time), function() {
          img.remove();
          ms++;
          if (ms == m) {
            if (pm.wait == "true") {
              that.kag.ftag.nextOrder();
            }
          }
        });
        if (pm.wait == "false") {
          that.kag.ftag.nextOrder();
        }
      } else {
        img = this.kag.layer.getLayer(pm.layer, pm.page);
        img = img.find("." + pm.name);
        img.remove();
        that.kag.ftag.nextOrder();
      }
    } else {
      img = this.kag.layer.getLayer(pm.layer, pm.page);
      img = img.find("." + pm.name);
      img.remove();
      this.kag.ftag.nextOrder();
    }
  }
};
tyrano.plugin.kag.tag.ptext = {
  vital : ["layer", "x", "y"],
  pm : {
    "layer" : "0",
    "page" : "fore",
    "x" : 0,
    "y" : 0,
    "vertical" : "false",
    "text" : "",
    "size" : "",
    "face" : "",
    "color" : "",
    "italic" : "",
    "bold" : "",
    "name" : "",
    "time" : "",
    "zindex" : "9999",
    "overwrite" : "false"
  },
  /**
   * @param {Object} data
   * @return {?}
   */
  start : function(data) {
    var that = this;
    if (data.face == "") {
      data.face = that.kag.stat.font.face;
    }
    if (data.color == "") {
      data.color = $.convertColor(that.kag.stat.font.color);
    } else {
      data.color = $.convertColor(data.color);
    }
    var style = {
      "color" : data.color,
      "font-weight" : data.bold,
      "font-style" : data.fontstyle,
      "font-size" : data.size + "px",
      "font-family" : data.face,
      "z-index" : "999",
      "text" : ""
    };
    var $rootElement = this.kag.layer.getLayer(data.layer, data.page);
    if (data.overwrite == "true" && data.name != "") {
      if ($("." + data.name).size() > 0) {
        $("." + data.name).html(data.text);
        this.kag.ftag.nextOrder();
        return false;
      }
    }
    var element = $("<p></p>");
    element.css("position", "absolute");
    element.css("top", data.y + "px");
    element.css("left", data.x + "px");
    element.css("width", "100%");
    if (data.vertical == "true") {
      element.addClass("vertical_text");
    }
    $.setName(element, data.name);
    element.html(data.text);
    this.kag.setStyles(element, style);
    if (data.layer == "fix") {
      element.addClass("fixlayer");
    }
    if (data.time != "") {
      element.css("opacity", 0);
      $rootElement.append(element);
      element.animate({
        "opacity" : 1
      }, parseInt(data.time), function() {
        that.kag.ftag.nextOrder();
      });
    } else {
      this.kag.ftag.nextOrder();
      $rootElement.append(element);
    }
  }
};
tyrano.plugin.kag.tag.mtext = {
  vital : ["x", "y"],
  pm : {
    "layer" : "0",
    "page" : "fore",
    "x" : 0,
    "y" : 0,
    "vertical" : "false",
    "text" : "",
    "size" : "",
    "face" : "",
    "color" : "",
    "italic" : "",
    "bold" : "",
    "name" : "",
    "zindex" : "9999",
    "fadeout" : "true",
    "time" : "2000",
    "in_effect" : "fadeIn",
    "in_delay" : "50",
    "in_delay_scale" : "1.5",
    "in_sync" : "false",
    "in_shuffle" : "false",
    "in_reverse" : "false",
    "wait" : "true",
    "out_effect" : "fadeOut",
    "out_delay" : "50",
    "out_scale_delay" : "",
    "out_sync" : "false",
    "out_shuffle" : "false",
    "out_reverse" : "false"
  },
  /**
   * @param {Object} data
   * @return {undefined}
   */
  start : function(data) {
    var that = this;
    if (data.face == "") {
      data.face = that.kag.stat.font.face;
    }
    if (data.color == "") {
      data.color = $.convertColor(that.kag.stat.font.color);
    } else {
      data.color = $.convertColor(data.color);
    }
    var style = {
      "color" : data.color,
      "font-weight" : data.bold,
      "font-style" : data.fontstyle,
      "font-size" : data.size + "px",
      "font-family" : data.face,
      "z-index" : "999",
      "text" : ""
    };
    var path = this.kag.layer.getLayer(data.layer, data.page);
    var wrapper = $("<p></p>");
    wrapper.css("position", "absolute");
    wrapper.css("top", data.y + "px");
    wrapper.css("left", data.x + "px");
    wrapper.css("width", "100%");
    if (data.vertical == "true") {
      wrapper.addClass("vertical_text");
    }
    $.setName(wrapper, data.name);
    wrapper.html(data.text);
    this.kag.setStyles(wrapper, style);
    if (data.layer == "fix") {
      wrapper.addClass("fixlayer");
    }
    path.append(wrapper);
    for (key in data) {
      if (data[key] == "true") {
        /** @type {boolean} */
        data[key] = true;
      } else {
        if (data[key] == "false") {
          /** @type {boolean} */
          data[key] = false;
        }
      }
    }
    wrapper.textillate({
      "loop" : data["fadeout"],
      "minDisplayTime" : data["time"],
      "in" : {
        "effect" : data["in_effect"],
        "delayScale" : data["in_delay_scale"],
        "delay" : data["in_delay"],
        "sync" : data["in_sync"],
        "shuffle" : data["in_shuffle"],
        "reverse" : data["in_reverse"],
        /**
         * @return {undefined}
         */
        "callback" : function() {
          if (data.fadeout == false && data.wait == true) {
            that.kag.ftag.nextOrder();
          }
        }
      },
      "out" : {
        "effect" : data["out_effect"],
        "delayScale" : data["out_delay_scale"],
        "delay" : data["out_delay"],
        "sync" : data["out_sync"],
        "shuffle" : data["out_shuffle"],
        "reverse" : data["out_reverse"],
        /**
         * @return {undefined}
         */
        "callback" : function() {
          wrapper.remove();
          if (data.wait == true) {
            that.kag.ftag.nextOrder();
          }
        }
      }
    });
    if (data.wait != true) {
      this.kag.ftag.nextOrder();
    }
  }
};
tyrano.plugin.kag.tag.backlay = {
  pm : {
    layer : ""
  },
  /**
   * @param {Object} args
   * @return {undefined}
   */
  start : function(args) {
    this.kag.layer.backlay(args.layer);
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.wt = {
  /**
   * @param {?} ui
   * @return {undefined}
   */
  start : function(ui) {
    this.kag.layer.hideEventLayer();
  }
};
tyrano.plugin.kag.tag.wb = {
  /**
   * @param {?} ui
   * @return {undefined}
   */
  start : function(ui) {
    this.kag.layer.hideEventLayer();
  }
};
tyrano.plugin.kag.tag.link = {
  pm : {
    target : null,
    storage : null
  },
  /**
   * @param {Object} d
   * @return {undefined}
   */
  start : function(d) {
    var that = this;
    var h2 = this.kag.setMessageCurrentSpan();
    h2.css("cursor", "pointer");
    (function() {
      var input = d.target;
      var ds = d.storage;
      that.kag.event.addEventElement({
        "tag" : "link",
        "j_target" : h2,
        "pm" : d
      });
      that.setEvent(h2, d);
    })();
    this.kag.ftag.nextOrder();
  },
  /**
   * @param {?} el
   * @param {Object} data
   * @return {undefined}
   */
  setEvent : function(el, data) {
    var page = data.target;
    var r20 = data.storage;
    var that = this;
    el.bind("click", function(event) {
      TYRANO.kag.ftag.nextOrderWithLabel(page, r20);
      TYRANO.kag.layer.showEventLayer();
      if (that.kag.stat.skip_link == "true") {
        event.stopPropagation();
      } else {
        /** @type {boolean} */
        that.kag.stat.is_skip = false;
      }
    });
    el.css("cursor", "pointer");
  }
};
tyrano.plugin.kag.tag.endlink = {
  /**
   * @param {?} ui
   * @return {undefined}
   */
  start : function(ui) {
    var j_span = this.kag.setMessageCurrentSpan();
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.s = {
  /**
   * @return {undefined}
   */
  start : function() {
    /** @type {boolean} */
    this.kag.stat.is_strong_stop = true;
    this.kag.layer.hideEventLayer();
  }
};
tyrano.plugin.kag.tag._s = {
  vital : [],
  pm : {},
  /**
   * @param {?} ui
   * @return {undefined}
   */
  start : function(ui) {
    this.kag.stat.strong_stop_recover_index = this.kag.ftag.current_order_index;
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.wait = {
  vital : ["time"],
  pm : {
    time : 0
  },
  /**
   * @param {Event} e
   * @return {undefined}
   */
  start : function(e) {
    var that = this;
    /** @type {boolean} */
    this.kag.stat.is_strong_stop = true;
    this.kag.layer.hideEventLayer();
    setTimeout(function() {
      /** @type {boolean} */
      that.kag.stat.is_strong_stop = false;
      that.kag.layer.showEventLayer();
      that.kag.ftag.nextOrder();
    }, e.time);
  }
};
tyrano.plugin.kag.tag.hidemessage = {
  /**
   * @return {undefined}
   */
  start : function() {
    /** @type {boolean} */
    this.kag.stat.is_hide_message = true;
    this.kag.layer.hideMessageLayers();
    this.kag.layer.layer_event.show();
  }
};
tyrano.plugin.kag.tag.quake = {
  vital : ["time"],
  pm : {
    count : 5,
    time : 300,
    timemode : "",
    hmax : "0",
    vmax : "10",
    wait : "true"
  },
  /**
   * @param {Object} options
   * @return {undefined}
   */
  start : function(options) {
    var that = this;
    if (options.hmax != "0") {
      $("." + this.kag.define.BASE_DIV_NAME).effect("shake", {
        times : parseInt(options.count),
        distance : parseInt(options.hmax),
        direction : "left"
      }, parseInt(options.time), function() {
        if (options.wait == "true") {
          that.kag.ftag.nextOrder();
        }
      });
    } else {
      if (options.vmax != "0") {
        $("." + this.kag.define.BASE_DIV_NAME).effect("shake", {
          times : parseInt(options.count),
          distance : parseInt(options.vmax),
          direction : "up"
        }, parseInt(options.time), function() {
          if (options.wait == "true") {
            that.kag.ftag.nextOrder();
          }
        });
      }
    }
    if (options.wait == "false") {
      that.kag.ftag.nextOrder();
    }
  }
};
tyrano.plugin.kag.tag.font = {
  pm : {},
  /**
   * @param {Object} p
   * @return {undefined}
   */
  start : function(p) {
    this.kag.setMessageCurrentSpan();
    var new_font = {};
    if (p.size) {
      this.kag.stat.font.size = p.size;
    }
    if (p.color) {
      this.kag.stat.font.color = $.convertColor(p.color);
    }
    if (p.bold) {
      this.kag.stat.font.bold = $.convertBold(p.bold);
    }
    if (p.face) {
      this.kag.stat.font.face = p.face;
    }
    if (p.italic) {
      this.kag.stat.font["italic"] = $.convertItalic(p.italic);
    }
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.deffont = {
  pm : {},
  /**
   * @param {Object} p
   * @return {undefined}
   */
  start : function(p) {
    var new_font = {};
    if (p.size) {
      this.kag.stat.default_font.size = p.size;
    }
    if (p.color) {
      this.kag.stat.default_font.color = $.convertColor(p.color);
    }
    if (p.bold) {
      this.kag.stat.default_font.bold = $.convertBold(p.bold);
    }
    if (p.face) {
      this.kag.stat.default_font.face = p.face;
    }
    if (p.italic) {
      this.kag.stat.default_font.italic = $.convertItalic(p.italic);
    }
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.delay = {
  pm : {
    speed : ""
  },
  /**
   * @param {Object} attrs
   * @return {undefined}
   */
  start : function(attrs) {
    if (attrs.speed != "") {
      /** @type {number} */
      this.kag.stat.ch_speed = parseInt(attrs.speed);
    }
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.resetdelay = {
  pm : {
    speed : ""
  },
  /**
   * @param {?} ui
   * @return {undefined}
   */
  start : function(ui) {
    /** @type {string} */
    this.kag.stat.ch_speed = "";
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.configdelay = {
  pm : {
    speed : ""
  },
  /**
   * @param {Object} attrs
   * @return {undefined}
   */
  start : function(attrs) {
    if (attrs.speed != "") {
      /** @type {string} */
      this.kag.stat.ch_speed = "";
      this.kag.config.chSpeed = attrs.speed;
      this.kag.ftag.startTag("eval", {
        "exp" : "sf._config_ch_speed = " + attrs.speed
      });
    }
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.nowait = {
  pm : {},
  /**
   * @param {?} ui
   * @return {undefined}
   */
  start : function(ui) {
    /** @type {boolean} */
    this.kag.stat.is_nowait = true;
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.endnowait = {
  pm : {},
  /**
   * @param {?} ui
   * @return {undefined}
   */
  start : function(ui) {
    /** @type {boolean} */
    this.kag.stat.is_nowait = false;
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.resetfont = {
  /**
   * @return {undefined}
   */
  start : function() {
    var j_span = this.kag.setMessageCurrentSpan();
    this.kag.stat.font = $.extend(true, {}, this.kag.stat.default_font);
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.layopt = {
  vital : ["layer"],
  pm : {
    layer : "",
    page : "fore",
    visible : "",
    left : "",
    top : "",
    opacity : "",
    autohide : false,
    index : 10
  },
  /**
   * @param {Object} pm
   * @return {undefined}
   */
  start : function(pm) {
    var that = this;
    if (pm.layer == "message") {
      pm.layer = this.kag.stat.current_layer;
      pm.page = this.kag.stat.current_page;
    }
    var element = this.kag.layer.getLayer(pm.layer, pm.page);
    if (pm.layer == "fix" || pm.layer == "fixlayer") {
      element = $("#tyrano_base").find(".fixlayer");
    }
    if (pm.visible != "") {
      if (pm.visible == "true") {
        if (pm.page == "fore") {
          element.css("display", "");
        }
        element.attr("l_visible", "true");
      } else {
        element.css("display", "none");
        element.attr("l_visible", "false");
      }
    }
    if (pm.left != "") {
      element.css("left", parseInt(pm.left));
    }
    if (pm.top != "") {
      element.css("top", parseInt(pm.top));
    }
    if (pm.opacity != "") {
      element.css("opacity", $.convertOpacity(pm.opacity));
    }
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag["ruby"] = {
  vital : ["text"],
  pm : {
    text : ""
  },
  /**
   * @param {Object} event
   * @return {undefined}
   */
  start : function(event) {
    var type = event.text;
    this.kag.stat.ruby_str = type;
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.cancelskip = {
  /**
   * @param {?} ui
   * @return {undefined}
   */
  start : function(ui) {
    /** @type {boolean} */
    this.kag.stat.is_skip = false;
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.locate = {
  pm : {
    x : null,
    y : null
  },
  /**
   * @param {?} coords
   * @return {undefined}
   */
  start : function(coords) {
    if (coords.x != null) {
      this.kag.stat.locate.x = coords.x;
    }
    if (coords.y != null) {
      this.kag.stat.locate.y = coords.y;
    }
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.button = {
  pm : {
    graphic : "",
    storage : null,
    target : null,
    ext : "",
    name : "",
    x : "",
    y : "",
    width : "",
    height : "",
    fix : "false",
    savesnap : "false",
    folder : "image",
    exp : "",
    prevar : "",
    visible : "true",
    hint : "",
    clickse : "",
    enterse : "",
    leavese : "",
    clickimg : "",
    enterimg : "",
    auto_next : "yes",
    role : ""
  },
  /**
   * @param {Object} data
   * @return {undefined}
   */
  start : function(data) {
    var that = this;
    /** @type {null} */
    var ele = null;
    if (data.role != "") {
      /** @type {string} */
      data.fix = "true";
    }
    if (data.fix == "false") {
      ele = this.kag.layer.getFreeLayer();
      ele.css("z-index", 999999);
    } else {
      ele = this.kag.layer.getLayer("fix");
    }
    /** @type {string} */
    var src = "";
    if ($.isHTTP(data.graphic)) {
      src = data.graphic;
    } else {
      /** @type {string} */
      src = "./data/" + data.folder + "/" + data.graphic;
    }
    var el = $("<img />");
    el.attr("src", src);
    el.css("position", "absolute");
    el.css("cursor", "pointer");
    el.css("z-index", 99999999);
    if (data.visible == "true") {
      el.show();
    } else {
      el.hide();
    }
    if (data.x == "") {
      el.css("left", this.kag.stat.locate.x + "px");
    } else {
      el.css("left", data.x + "px");
    }
    if (data.y == "") {
      el.css("top", this.kag.stat.locate.y + "px");
    } else {
      el.css("top", data.y + "px");
    }
    if (data.fix != "false") {
      el.addClass("fixlayer");
    }
    if (data.width != "") {
      el.css("width", data.width + "px");
    }
    if (data.height != "") {
      el.css("height", data.height + "px");
    }
    if (data.hint != "") {
      el.attr({
        "title" : data.hint,
        "alt" : data.hint
      });
    }
    $.setName(el, data.name);
    that.kag.event.addEventElement({
      "tag" : "button",
      "j_target" : el,
      "pm" : data
    });
    that.setEvent(el, data);
    ele.append(el);
    if (data.fix == "false") {
      ele.show();
    }
    this.kag.ftag.nextOrder();
  },
  /**
   * @param {Object} el
   * @param {Object} c
   * @return {undefined}
   */
  setEvent : function(el, c) {
    var that = TYRANO;
    (function() {
      var target = c.target;
      var cl = c.storage;
      /** @type {Object} */
      var options = c;
      var r20 = that.kag.embScript(c.preexp);
      /** @type {boolean} */
      var symbol = false;
      el.hover(function() {
        if (options.enterse != "") {
          that.kag.ftag.startTag("playse", {
            "storage" : options.enterse,
            "stop" : true
          });
        }
        if (options.enterimg != "") {
          /** @type {string} */
          var classes = "";
          if ($.isHTTP(options.enterimg)) {
            classes = options.enterimg;
          } else {
            /** @type {string} */
            classes = "./data/" + options.folder + "/" + options.enterimg;
          }
          $(this).attr("src", classes);
        }
      }, function() {
        if (options.leavese != "") {
          that.kag.ftag.startTag("playse", {
            "storage" : options.leavese,
            "stop" : true
          });
        }
        if (options.enterimg != "") {
          /** @type {string} */
          var classes = "";
          if ($.isHTTP(options.graphic)) {
            classes = options.graphic;
          } else {
            /** @type {string} */
            classes = "./data/" + options.folder + "/" + options.graphic;
          }
          $(this).attr("src", classes);
        }
      });
      el.click(function(event) {
        if (options.clickse != "") {
          that.kag.ftag.startTag("playse", {
            "storage" : options.clickse
          });
        }
        if (options.clickimg != "") {
          /** @type {string} */
          var text = "";
          if ($.isHTTP(options.clickimg)) {
            text = options.clickimg;
          } else {
            /** @type {string} */
            text = "./data/" + options.folder + "/" + options.clickimg;
          }
          el.attr("src", text);
        }
        if (symbol == true && options.fix == "false") {
          return false;
        }
        if (that.kag.stat.is_strong_stop != true && options.fix == "false") {
          return false;
        }
        /** @type {boolean} */
        symbol = true;
        if (options.exp != "") {
          that.kag.embScript(options.exp, r20);
        }
        if (options.savesnap == "true") {
          if (that.kag.stat.is_stop == true) {
            return false;
          }
          that.kag.menu.snapSave(that.kag.stat.current_message_str);
        }
        if (that.kag.layer.layer_event.css("display") == "none" && that.kag.stat.is_strong_stop != true) {
          return false;
        }
        if (options.role != "") {
          /** @type {boolean} */
          that.kag.stat.is_skip = false;
          if (options.role != "auto") {
            that.kag.ftag.startTag("autostop", {});
          }
          switch(options.role) {
            case "save":
              that.kag.menu.displaySave();
              break;
            case "load":
              that.kag.menu.displayLoad();
              break;
            case "window":
              that.kag.layer.hideMessageLayers();
              break;
            case "title":
              $.confirm($.lang("go_title"), function() {
                location.reload();
              }, function() {
                return false;
              });
              break;
            case "menu":
              that.kag.menu.showMenu();
              break;
            case "skip":
              that.kag.ftag.startTag("skipstart", {});
              break;
            case "backlog":
              that.kag.menu.displayLog();
              break;
            case "fullscreen":
              that.kag.menu.screenFull();
              break;
            case "quicksave":
              that.kag.menu.setQuickSave();
              break;
            case "quickload":
              that.kag.menu.loadQuickSave();
              break;
            case "auto":
              if (that.kag.stat.is_auto == true) {
                that.kag.ftag.startTag("autostop", {});
              } else {
                that.kag.ftag.startTag("autostart", {});
              }
              break;
            case "sleepgame":
              if (that.kag.tmp.sleep_game != null) {
                return false;
              }
              that.kag.tmp.sleep_game = {};
              that.kag.ftag.startTag("sleepgame", options);
              break;
          }
          event.stopPropagation();
          return false;
        }
        that.kag.layer.showEventLayer();
        if (options.role == "" && options.fix == "true") {
          var fmt = that.kag.getStack("call");
          if (fmt == null) {
            if (that.kag.stat.is_strong_stop == true) {
              /** @type {string} */
              options.auto_next = "stop";
            } else {
            }
            that.kag.ftag.startTag("call", options);
          } else {
            that.kag.log("call\u30b9\u30bf\u30c3\u30af\u304c\u6b8b\u3063\u3066\u3044\u308b\u5834\u5408\u3001fix\u30dc\u30bf\u30f3\u306f\u53cd\u5fdc\u3057\u307e\u305b\u3093");
            that.kag.log(fmt);
            return false;
          }
        } else {
          that.kag.ftag.startTag("jump", options);
        }
        if (that.kag.stat.skip_link == "true") {
          event.stopPropagation();
        } else {
          /** @type {boolean} */
          that.kag.stat.is_skip = false;
        }
      });
    })();
  }
};
tyrano.plugin.kag.tag.glink = {
  pm : {
    color : "black",
    font_color : "0xffffff",
    storage : null,
    target : null,
    name : "",
    text : "",
    x : "auto",
    y : "",
    width : "",
    height : "",
    size : 30,
    graphic : "",
    enterimg : "",
    clickse : "",
    enterse : "",
    leavese : "",
    do_cm : "",
    face : ""
  },
  /**
   * @param {Object} data
   * @return {undefined}
   */
  start : function(data) {
    var that = this;
    /** @type {null} */
    var ele = null;
    ele = this.kag.layer.getFreeLayer();
    ele.css("z-index", 999999);
    var el = $("<div class='glink_button'>" + data.text + "</div>");
    el.css("position", "absolute");
    el.css("cursor", "pointer");
    el.css("z-index", 99999999);
    el.css("font-size", data.size + "px");
    el.css("color", $.convertColor(data.font_color));
    if (data.height != "") {
      el.css("height", data.height + "px");
    }
    if (data.width != "") {
      el.css("width", data.width + "px");
    }
    if (data.graphic != "") {
      el.removeClass("glink_button").addClass("button_graphic");
      /** @type {string} */
      var img_url = "./data/image/" + data.graphic;
      el.css("background-image", "url(" + img_url + ")");
      el.css("background-repeat", "no-repeat");
      el.css("background-position", "center center");
      el.css("background-size", "100% 100%");
    } else {
      el.addClass(data.color);
    }
    if (data.face != "") {
      el.css("font-family", data.face);
    } else {
      if (that.kag.stat.font.face != "") {
        el.css("font-family", that.kag.stat.font.face);
      }
    }
    if (data.x == "auto") {
      /** @type {number} */
      var millis = parseInt(that.kag.config.scWidth);
      /** @type {number} */
      var clientTop = Math.floor(parseInt(el.css("width")) / 2);
      /** @type {number} */
      var scrollTop = Math.floor(millis / 2);
      /** @type {number} */
      var top = scrollTop - clientTop;
      el.css("left", top + "px");
    } else {
      if (data.x == "") {
        el.css("left", this.kag.stat.locate.x + "px");
      } else {
        el.css("left", data.x + "px");
      }
    }
    if (data.y == "") {
      el.css("top", this.kag.stat.locate.y + "px");
    } else {
      el.css("top", data.y + "px");
    }
    $.setName(el, data.name);
    that.kag.event.addEventElement({
      "tag" : "glink",
      "j_target" : el,
      "pm" : data
    });
    this.setEvent(el, data);
    ele.append(el);
    ele.show();
    this.kag.ftag.nextOrder();
  },
  /**
   * @param {Object} el
   * @param {Object} c
   * @return {undefined}
   */
  setEvent : function(el, c) {
    var that = TYRANO;
    (function() {
      var target = c.target;
      var cl = c.storage;
      /** @type {Object} */
      var options = c;
      var r20 = that.kag.embScript(c.preexp);
      /** @type {boolean} */
      var button_clicked = false;
      el.click(function(event) {
        if (options.clickse != "") {
          that.kag.ftag.startTag("playse", {
            "storage" : options.clickse
          });
        }
        if (that.kag.stat.is_strong_stop != true) {
          return false;
        }
        /** @type {boolean} */
        button_clicked = true;
        if (options.exp != "") {
          that.kag.embScript(options.exp, r20);
        }
        that.kag.layer.showEventLayer();
        if(options.do_cm == "") {
          that.kag.ftag.startTag("cm", {});
        }
        that.kag.ftag.startTag("jump", options);
        if (that.kag.stat.skip_link == "true") {
          event.stopPropagation();
        } else {
          /** @type {boolean} */
          that.kag.stat.is_skip = false;
        }
      });
      el.hover(function() {
        if (options.enterimg != "") {
          /** @type {string} */
          var enterimg_url = "./data/image/" + options.enterimg;
          el.css("background-image", "url(" + enterimg_url + ")");
        }
        if (options.enterse != "") {
          that.kag.ftag.startTag("playse", {
            "storage" : options.enterse,
            "stop" : true
          });
        }
      }, function() {
        if (options.enterimg != "") {
          /** @type {string} */
          var img_url = "./data/image/" + options.graphic;
          el.css("background-image", "url(" + img_url + ")");
        }
        if (options.leavese != "") {
          that.kag.ftag.startTag("playse", {
            "storage" : options.leavese,
            "stop" : true
          });
        }
      });
    })();
  }
};
tyrano.plugin.kag.tag.clickable = {
  vital : ["width", "height"],
  pm : {
    width : "0",
    height : "0",
    x : "",
    y : "",
    border : "none",
    color : "",
    mouseopacity : "",
    opacity : "140",
    storage : null,
    target : null,
    name : ""
  },
  /**
   * @param {Object} d
   * @return {undefined}
   */
  start : function(d) {
    var that = this;
    var bar = this.kag.layer.getFreeLayer();
    bar.css("z-index", 9999999);
    var element = $("<div />");
    element.css("position", "absolute");
    element.css("cursor", "pointer");
    element.css("top", this.kag.stat.locate.y + "px");
    element.css("left", this.kag.stat.locate.x + "px");
    element.css("width", d.width + "px");
    element.css("height", d.height + "px");
    element.css("opacity", $.convertOpacity(d.opacity));
    element.css("background-color", $.convertColor(d.color));
    element.css("border", $.replaceAll(d.border, ":", " "));
    if (d.x != "") {
      element.css("left", parseInt(d.x));
    }
    if (d.y != "") {
      element.css("top", parseInt(d.y));
    }
    that.kag.event.addEventElement({
      "tag" : "clickable",
      "j_target" : element,
      "pm" : d
    });
    that.setEvent(element, d);
    bar.append(element);
    bar.show();
    this.kag.ftag.nextOrder();
  },
  /**
   * @param {Object} el
   * @param {Object} data
   * @return {undefined}
   */
  setEvent : function(el, data) {
    var that = TYRANO;
    (function() {
      var target = data.target;
      var storage = data.storage;
      /** @type {Object} */
      var pm = data;
      if (pm.mouseopacity != "") {
        el.bind("mouseover", function() {
          el.css("opacity", $.convertOpacity(pm.mouseopacity));
        });
        el.bind("mouseout", function() {
          el.css("opacity", $.convertOpacity(pm.opacity));
        });
      }
      el.click(function() {
        var dfd = function(that) {
          if (that.kag.stat.is_strong_stop != true) {
            return false;
          }
          return true;
        }(that);
        if (dfd == false) {
          return false;
        }
        that.kag.ftag.startTag("cm", {});
        that.kag.layer.showEventLayer();
        that.kag.ftag.startTag("jump", pm);
      });
    })();
  }
};
tyrano.plugin.kag.tag.glyph = {
  pm : {
    line : "nextpage.gif",
    layer : "message0",
    fix : "false",
    left : 0,
    top : 0
  },
  /**
   * @param {Object} options
   * @return {undefined}
   */
  start : function(options) {
    var that = this;
    $(".glyph_image").remove();
    if (options.fix == "true") {
      var ele = this.kag.layer.getLayer(options.layer);
      var el = $("<img class='glyph_image' />");
      el.attr("src", "./tyrano/images/kag/" + options.line);
      el.css("position", "absolute");
      el.css("z-index", 99999);
      el.css("top", options.top + "px");
      el.css("left", options.left + "px");
      el.css("display", "none");
      ele.append(el);
      /** @type {string} */
      this.kag.stat.flag_glyph = "true";
    } else {
      /** @type {string} */
      this.kag.stat.flag_glyph = "false";
    }
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.trans = {
  vital : ["time", "layer"],
  pm : {
    layer : "base",
    method : "crossfade",
    children : false,
    time : 1500
  },
  /**
   * @param {Object} scope
   * @return {undefined}
   */
  start : function(scope) {
    this.kag.ftag.hideNextImg();
    var that = this;
    /** @type {number} */
    var firingIndex = 0;
    var index = $.countObj(this.kag.layer.map_layer_fore);
    if (scope.children == "false") {
      /** @type {number} */
      index = 0;
    }
    var context = $.cloneObject(this.kag.layer.map_layer_fore);
    var childNodes = $.cloneObject(this.kag.layer.map_layer_back);
    for (key in context) {
      if (scope.children == true || key === scope.layer) {
        (function() {
          var c = key;
          var tail = context[c];
          var child = childNodes[c];
          if (c.indexOf("message") != -1 && child.attr("l_visible") == "false") {
            firingIndex++;
            that.kag.layer.forelay(c);
          } else {
            $.trans(scope.method, tail, parseInt(scope.time), "hide", function() {
            });
            child.css("display", "none");
            $.trans(scope.method, child, parseInt(scope.time), "show", function() {
              firingIndex++;
              that.kag.layer.forelay(c);
              if (index <= firingIndex) {
                that.kag.ftag.completeTrans();
              }
              that.kag.ftag.hideNextImg();
            });
          }
        })();
      }
    }
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.bg = {
  vital : ["storage"],
  pm : {
    storage : "",
    method : "crossfade",
    wait : "true",
    time : 3E3
  },
  /**
   * @param {Object} pm
   * @return {undefined}
   */
  start : function(pm) {
    this.kag.ftag.hideNextImg();
    var that = this;
    if (pm.time == 0) {
      /** @type {string} */
      pm.wait = "false";
    }
    /** @type {string} */
    var storage_url = "./data/bgimage/" + pm.storage;
    if ($.isHTTP(pm.storage)) {
      storage_url = pm.storage;
    }
    this.kag.preload(storage_url, function() {
      var instance = that.kag.layer.getLayer("base", "fore");
      var $this = instance.clone(false);
      $this.css("background-image", "url(" + storage_url + ")");
      $this.css("display", "none");
      instance.after($this);
      that.kag.ftag.hideNextImg();
      that.kag.layer.updateLayer("base", "fore", $this);
      if (pm.wait == "true") {
        that.kag.layer.hideEventLayer();
      }
      $.trans(pm.method, instance, parseInt(pm.time), "hide", function() {
        instance.remove();
      });
      $.trans(pm.method, $this, parseInt(pm.time), "show", function() {
        $this.css("opacity", 1);
        if (pm.wait == "true") {
          that.kag.layer.showEventLayer();
          that.kag.ftag.nextOrder();
        }
      });
    });
    if (pm.wait == "false") {
      this.kag.ftag.nextOrder();
    }
  }
};
