tyrano.plugin.kag.tag.playbgm = {
  vital : ["storage"],
  pm : {
    loop : "true",
    storage : "",
    fadein : "false",
    time : 2E3,
    volume : "",
    target : "bgm",
    click : "false",
    stop : "false"
  },
  /**
   * @param {Object} pm
   * @return {undefined}
   */
  start : function(pm) {
    var that = this;
    if (pm.target == "bgm" && that.kag.stat.play_bgm == false) {
      that.kag.ftag.nextOrder();
      return;
    }
    if (pm.target == "se" && that.kag.stat.play_se == false) {
      that.kag.ftag.nextOrder();
      return;
    }
    if (that.kag.define.FLAG_APRI == true) {
      that.playGap(pm);
    } else {
      if ($.userenv() != "pc") {
        this.kag.layer.hideEventLayer();
        if (this.kag.stat.is_skip == true && pm.target == "se") {
          that.kag.layer.showEventLayer();
          that.kag.ftag.nextOrder();
        } else {
          if (pm.click == "true") {
            $(".tyrano_base").bind("click.bgm", function() {
              that.play(pm);
              $(".tyrano_base").unbind("click.bgm");
              that.kag.layer.showEventLayer();
            });
          } else {
            that.play(pm);
            $(".tyrano_base").unbind("click.bgm");
            that.kag.layer.showEventLayer();
          }
        }
      } else {
        that.play(pm);
      }
    }
  },
  /**
   * @param {Object} pm
   * @return {undefined}
   */
  play : function(pm) {
    var that = this;
    /** @type {string} */
    var target = "bgm";
    if (pm.target == "se") {
      /** @type {string} */
      target = "sound";
      /** @type {boolean} */
      this.kag.tmp.is_se_play = true;
    } else {
      /** @type {boolean} */
      this.kag.tmp.is_bgm_play = true;
    }
    /** @type {number} */
    var volume = 1;
    if (pm.volume != "") {
      /** @type {number} */
      volume = parseFloat(parseInt(pm.volume) / 100);
    } else {
      if (target === "bgm") {
        if (!this.kag.config.defaultBgmVolume) {
          /** @type {number} */
          volume = 1;
        } else {
          /** @type {number} */
          volume = parseFloat(parseInt(this.kag.config.defaultBgmVolume) / 100);
        }
      } else {
        if (!this.kag.config.defaultSeVolume) {
          /** @type {number} */
          volume = 1;
        } else {
          /** @type {number} */
          volume = parseFloat(parseInt(this.kag.config.defaultSeVolume) / 100);
        }
      }
    }
    /** @type {string} */
    var data = "";
    var key = $.getBrowser();
    var tmp = pm.storage;
    if (this.kag.config.mediaFormatDefault != "mp3") {
      if (key == "msie" || key == "safari") {
        tmp = $.replaceAll(tmp, ".ogg", ".m4a");
      }
    }
    if ($.isHTTP(pm.storage)) {
      data = tmp;
    } else {
      /** @type {string} */
      data = "./data/" + target + "/" + tmp;
    }
    var audio = new Audio(data);
    /** @type {number} */
    audio.volume = volume;
    if (pm.loop == "true") {
      /** @type {boolean} */
      audio.loop = true;
      /**
       * @return {undefined}
       */
      audio.onended = function() {
        this.play();
      };
    }
    if (target === "bgm") {
      this.kag.tmp.map_bgm[tmp] = audio;
      that.kag.stat.current_bgm = tmp;
    } else {
      this.kag.tmp.map_se[tmp] = audio;
    }
    audio.play();
    if (pm.fadein == "true") {
      var sp = jQuery.extend($("<div>")[0], {
        volume : 0
      });
      $(sp).stop().animate({
        "volume" : volume
      }, {
        easing : "linear",
        duration : parseInt(pm.time),
        /**
         * @return {undefined}
         */
        step : function() {
          audio.volume = this.volume;
        },
        /**
         * @return {undefined}
         */
        complete : function() {
        }
      });
    }
    audio.addEventListener("ended", function() {
      if (pm.target == "se") {
        /** @type {boolean} */
        that.kag.tmp.is_se_play = false;
        if (that.kag.tmp.is_se_play_wait == true) {
          /** @type {boolean} */
          that.kag.tmp.is_se_play_wait = false;
          that.kag.ftag.nextOrder();
        }
      } else {
        if (pm.target == "bgm") {
          /** @type {boolean} */
          that.kag.tmp.is_bgm_play = false;
          if (that.kag.tmp.is_bgm_play_wait == true) {
            /** @type {boolean} */
            that.kag.tmp.is_bgm_play_wait = false;
            that.kag.ftag.nextOrder();
          }
        }
      }
    });
    if (pm.stop == "false") {
      this.kag.ftag.nextOrder();
    }
  },
  /**
   * @param {Object} pm
   * @return {undefined}
   */
  playGap : function(pm) {
    var that = this;
    /** @type {string} */
    var target = "bgm";
    if (pm.target == "se") {
      /** @type {string} */
      target = "sound";
    }
    /** @type {null} */
    var audio_obj = null;
    if (target === "bgm") {
      this.kag.stat.current_bgm = pm.storage;
    }
    /** @type {string} */
    var src_url = "./data/" + target + "/" + pm.storage;
    if ($.userenv() === "android" || $.userenv() === "andoroid") {
      /** @type {string} */
      src_url = $.getBaseURL() + "data/" + target + "/" + pm.storage;
    }
    audio_obj = new Media(src_url, function() {
      if (pm.loop == "true") {
        /** @type {null} */
        var tmp_obj = null;
        if (pm.target == "bgm") {
          tmp_obj = that.kag.tmp.map_bgm[pm.storage];
        } else {
          tmp_obj = that.kag.tmp.map_se[pm.storage];
        }
        if (tmp_obj != null) {
          audio_obj.play();
        }
      }
    });
    if (pm.target == "bgm") {
      this.kag.tmp.map_bgm[pm.storage] = audio_obj;
    } else {
      this.kag.tmp.map_se[pm.storage] = audio_obj;
    }
    this.playAudio(audio_obj, pm, target);
    if (pm.stop == "false") {
      this.kag.ftag.nextOrder();
    }
  },
  /**
   * @param {Object} audio_obj
   * @param {(Object|string)} value
   * @param {string} target
   * @return {undefined}
   */
  playAudio : function(audio_obj, value, target) {
    /** @type {number} */
    var vol = 1;
    if (value.volume != "") {
      /** @type {number} */
      vol = parseFloat(parseInt(value.volume) / 100);
    } else {
      if (target === "bgm") {
        if (!this.kag.config.defaultBgmVolume) {
          /** @type {number} */
          vol = 1;
        } else {
          /** @type {number} */
          vol = parseFloat(parseInt(this.kag.config.defaultBgmVolume) / 100);
        }
      } else {
        if (!this.kag.config.defaultSeVolume) {
          /** @type {number} */
          vol = 1;
        } else {
          /** @type {number} */
          vol = parseFloat(parseInt(this.kag.config.defaultSeVolume) / 100);
        }
      }
    }
    audio_obj.play();
    audio_obj.setVolume(vol);
  },
  /**
   * @param {Object} pm
   * @return {undefined}
   */
  playSwf : function(pm) {
    /** @type {string} */
    var target = "bgm";
    if (pm.target == "se") {
      /** @type {string} */
      target = "sound";
    }
    /** @type {number} */
    var repeat = 1;
    if (pm.loop == "true") {
      /** @type {number} */
      repeat = 9999;
    }
    /** @type {string} */
    target = "bgm";
    if (pm.target == "se") {
      /** @type {string} */
      target = "sound";
    }
    /** @type {string} */
    var storage_url = "";
    if ($.isHTTP(pm.storage)) {
      storage_url = pm.storage;
    } else {
      /** @type {string} */
      storage_url = "./data/" + target + "/" + pm.storage;
    }
    if (target === "bgm") {
      this.kag.stat.current_bgm = pm.storage;
      this.kag.sound_swf.playMusic(storage_url, repeat);
    } else {
      this.kag.sound_swf.playSound(storage_url, repeat);
    }
    if (pm.stop == "false") {
      this.kag.ftag.nextOrder();
    }
  }
};
tyrano.plugin.kag.tag.stopbgm = {
  pm : {
    fadeout : "false",
    time : 2E3,
    target : "bgm",
    stop : "false"
  },
  /**
   * @param {Event} pm
   * @return {undefined}
   */
  start : function(pm) {
    var that = this;
    /** @type {null} */
    var target_map = null;
    if (pm.target == "bgm") {
      target_map = this.kag.tmp.map_bgm;
      /** @type {boolean} */
      that.kag.tmp.is_bgm_play = false;
      /** @type {boolean} */
      that.kag.tmp.is_bgm_play_wait = false;
    } else {
      target_map = this.kag.tmp.map_se;
      /** @type {boolean} */
      that.kag.tmp.is_se_play = false;
      /** @type {boolean} */
      that.kag.tmp.is_se_play_wait = false;
    }
    var browser = $.getBrowser();
    if (that.kag.define.FLAG_APRI == true) {
      for (key in target_map) {
        (function() {
          var _key = key;
          /** @type {null} */
          var _audio_obj = null;
          if (pm.target === "bgm") {
            _audio_obj = target_map[_key];
            if (pm.stop == "false") {
              /** @type {string} */
              that.kag.stat.current_bgm = "";
            }
          } else {
            _audio_obj = target_map[_key];
          }
          if (pm.target === "bgm") {
            /** @type {null} */
            that.kag.tmp.map_bgm[_key] = null;
            delete that.kag.tmp.map_bgm[_key];
          } else {
            /** @type {null} */
            that.kag.tmp.map_se[_key] = null;
            delete that.kag.tmp.map_se[_key];
          }
          _audio_obj.stop();
          _audio_obj.release();
        })();
      }
    } else {
      for (key in target_map) {
        (function() {
          var _key = key;
          /** @type {null} */
          var _audio_obj = null;
          if (pm.target === "bgm") {
            _audio_obj = target_map[_key];
            if (pm.stop == "false") {
              /** @type {string} */
              that.kag.stat.current_bgm = "";
            }
          } else {
            _audio_obj = target_map[_key];
          }
          if (pm.fadeout == "true") {
            var sp = jQuery.extend($("<div>")[0], {
              "volume" : _audio_obj.volume
            });
            $(sp).stop().animate({
              volume : 0
            }, {
              easing : "linear",
              duration : parseInt(pm.time),
              /**
               * @return {undefined}
               */
              step : function() {
                _audio_obj.volume = this.volume;
              },
              /**
               * @return {undefined}
               */
              complete : function() {
                _audio_obj.pause();
              }
            });
          } else {
            _audio_obj.pause();
            if (pm.target === "bgm") {
              delete that.kag.tmp.map_bgm[_key];
            } else {
              delete that.kag.tmp.map_se[_key];
            }
          }
        })();
      }
    }
    if (pm.stop == "false") {
      this.kag.ftag.nextOrder();
    }
  }
};
tyrano.plugin.kag.tag.fadeinbgm = {
  vital : ["storage", "time"],
  pm : {
    loop : "true",
    storage : "",
    fadein : "true",
    time : 2E3
  },
  /**
   * @param {Event} pm
   * @return {undefined}
   */
  start : function(pm) {
    if (parseInt(pm.time) <= 100) {
      /** @type {number} */
      pm.time = 100;
    }
    this.kag.ftag.startTag("playbgm", pm);
  }
};
tyrano.plugin.kag.tag.fadeoutbgm = {
  pm : {
    loop : "true",
    storage : "",
    fadeout : "true",
    time : 2E3
  },
  /**
   * @param {?} pm
   * @return {undefined}
   */
  start : function(pm) {
    this.kag.ftag.startTag("stopbgm", pm);
  }
};
tyrano.plugin.kag.tag.xchgbgm = {
  vital : ["storage", "time"],
  pm : {
    loop : "true",
    storage : "",
    fadein : "true",
    fadeout : "true",
    time : 2E3
  },
  /**
   * @param {?} pm
   * @return {undefined}
   */
  start : function(pm) {
    this.kag.ftag.startTag("stopbgm", pm);
    this.kag.ftag.startTag("playbgm", pm);
  }
};
tyrano.plugin.kag.tag.playse = {
  vital : ["storage"],
  pm : {
    storage : "",
    target : "se",
    volume : "",
    loop : "false",
    clear : "false"
  },
  /**
   * @param {Object} pm
   * @return {undefined}
   */
  start : function(pm) {
    if (pm.clear == "true") {
      this.kag.ftag.startTag("stopbgm", {
        target : "se",
        stop : "true"
      });
    }
    this.kag.ftag.startTag("playbgm", pm);
  }
};
tyrano.plugin.kag.tag.stopse = {
  pm : {
    storage : "",
    fadeout : "false",
    time : 2E3,
    target : "se"
  },
  /**
   * @param {?} pm
   * @return {undefined}
   */
  start : function(pm) {
    this.kag.ftag.startTag("stopbgm", pm);
  }
};
tyrano.plugin.kag.tag.fadeinse = {
  vital : ["storage", "time"],
  pm : {
    storage : "",
    target : "se",
    loop : "false",
    volume : "",
    fadein : "true",
    time : "2000"
  },
  /**
   * @param {Event} pm
   * @return {undefined}
   */
  start : function(pm) {
    if (parseInt(pm.time) <= 100) {
      /** @type {number} */
      pm.time = 100;
    }
    this.kag.ftag.startTag("playbgm", pm);
  }
};
tyrano.plugin.kag.tag.fadeoutse = {
  pm : {
    storage : "",
    target : "se",
    loop : "false",
    fadeout : "true"
  },
  /**
   * @param {?} pm
   * @return {undefined}
   */
  start : function(pm) {
    this.kag.ftag.startTag("stopbgm", pm);
  }
};
tyrano.plugin.kag.tag.bgmopt = {
  pm : {
    volume : "100",
    effect : "true"
  },
  /**
   * @param {(Object|string)} args
   * @return {undefined}
   */
  start : function(args) {
    var iterable = this.kag.tmp.map_bgm;
    this.kag.config.defaultBgmVolume = args.volume;
    this.kag.ftag.startTag("eval", {
      "exp" : "sf._system_config_bgm_volume = " + args.volume
    });
    /** @type {number} */
    var amount = parseFloat(parseInt(args.volume) / 100);
    if (args.effect == "true") {
      for (key in iterable) {
        /** @type {number} */
        iterable[key].setVolume(amount);
      }
    }
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.seopt = {
  pm : {
    volume : "100",
    effect : "true"
  },
  /**
   * @param {(Object|string)} args
   * @return {undefined}
   */
  start : function(args) {
    var iterable = this.kag.tmp.map_se;
    this.kag.config.defaultSeVolume = args.volume;
    this.kag.ftag.startTag("eval", {
      "exp" : "sf._system_config_se_volume = " + args.volume
    });
    /** @type {number} */
    var amount = parseFloat(parseInt(args.volume) / 100);
    if (args.effect == "true" && this.kag.define.FLAG_APRI == false) {
      for (key in iterable) {
        /** @type {number} */
        iterable[key].volume = amount;
      }
    }
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.wbgm = {
  pm : {},
  /**
   * @return {undefined}
   */
  start : function() {
    if (this.kag.tmp.is_bgm_play == true) {
      /** @type {boolean} */
      this.kag.tmp.is_bgm_play_wait = true;
    } else {
      this.kag.ftag.nextOrder();
    }
  }
};
tyrano.plugin.kag.tag.wse = {
  pm : {},
  /**
   * @return {undefined}
   */
  start : function() {
    if (this.kag.tmp.is_se_play == true) {
      /** @type {boolean} */
      this.kag.tmp.is_se_play_wait = true;
    } else {
      this.kag.ftag.nextOrder();
    }
  }
};
