tyrano.plugin.kag.tag.loadjs = {
  vital : ["storage"],
  pm : {
    storage : ""
  },
  /**
   * @param {Object} pm
   * @return {undefined}
   */
  start : function(pm) {
    var that = this;
    $.getScript("./data/others/" + pm.storage, function() {
      that.kag.ftag.nextOrder();
    });
  }
};
tyrano.plugin.kag.tag.movie = {
  vital : ["storage"],
  pm : {
    storage : "",
    volume : "",
    skip : "false",
    bgmode : "false",
    loop : "false"
  },
  /**
   * @param {Object} settings
   * @return {undefined}
   */
  start : function(settings) {
    var that = this;
    if ($.userenv() != "pc") {
      this.kag.layer.showEventLayer();
      $(".tyrano_base").bind("click.movie", function(dataAndEvents) {
        that.playVideo(settings);
        $(".tyrano_base").unbind("click.movie");
      });
    } else {
      if ($.getBrowser() == "firefox" || $.getBrowser() == "opera") {
        settings.storage = $.replaceAll(settings.storage, ".mp4", ".webm");
      }
      that.playVideo(settings);
    }
  },
  /**
   * @param {Object} settings
   * @return {undefined}
   */
  playVideo : function(settings) {
    var that = this;
    /** @type {string} */
    var url = "./data/video/" + settings.storage;
    /** @type {Element} */
    var video = document.createElement("video");
    /** @type {string} */
    video.id = "bgmovie";
    /** @type {string} */
    video.src = url;
    if (settings.volume != "") {
      /** @type {number} */
      video.volume = parseFloat(parseInt(settings.volume) / 100);
    } else {
      if (typeof this.kag.config.defaultMovieVolume != "undefined") {
        /** @type {number} */
        video.volume = parseFloat(parseInt(this.kag.config.defaultMovieVolume) / 100);
      }
    }
    /** @type {string} */
    video.style.backgroundColor = "black";
    /** @type {string} */
    video.style.position = "absolute";
    /** @type {string} */
    video.style.top = "0px";
    /** @type {string} */
    video.style.left = "0px";
    /** @type {string} */
    video.style.width = "100%";
    /** @type {string} */
    video.style.height = "100%";
    /** @type {boolean} */
    video.autoplay = true;
    /** @type {boolean} */
    video.autobuffer = true;
    if (settings.bgmode == "true") {
      /** @type {boolean} */
      that.kag.tmp.video_playing = true;
      /** @type {number} */
      video.style.zIndex = 1;
      if (settings.loop == "true") {
        /** @type {boolean} */
        video.loop = true;
      } else {
        /** @type {boolean} */
        video.loop = false;
      }
      video.addEventListener("ended", function(dataAndEvents) {
        if (that.kag.stat.video_stack == null) {
          /** @type {boolean} */
          that.kag.tmp.video_playing = false;
          if (that.kag.stat.is_wait_bgmovie == true) {
            that.kag.ftag.nextOrder();
            /** @type {boolean} */
            that.kag.stat.is_wait_bgmovie = false;
          }
        } else {
          var config = that.kag.stat.video_stack;
          if (config.loop == "true") {
            /** @type {boolean} */
            video.loop = true;
          } else {
            /** @type {boolean} */
            video.loop = false;
          }
          /** @type {string} */
          video.src = "./data/video/" + config.storage;
          video.load();
          video.play();
          /** @type {null} */
          that.kag.stat.video_stack = null;
          that.kag.ftag.nextOrder();
        }
      });
    } else {
      /** @type {number} */
      video.style.zIndex = 199999;
      video.addEventListener("ended", function(dataAndEvents) {
        $(".tyrano_base").find("video").remove();
        that.kag.ftag.nextOrder();
      });
      if (settings.skip == "true") {
        video.addEventListener("click", function(dataAndEvents) {
          $(".tyrano_base").find("video").remove();
          that.kag.ftag.nextOrder();
        });
      }
    }
    document.getElementById("tyrano_base").appendChild(video);
    video.load();
    video.play();
  }
};
tyrano.plugin.kag.tag.bgmovie = {
  vital : ["storage"],
  pm : {
    storage : "",
    volume : "",
    loop : "true",
    stop : "false"
  },
  /**
   * @param {Object} options
   * @return {undefined}
   */
  start : function(options) {
    var that = this;
    /** @type {string} */
    options.skip = "false";
    /** @type {string} */
    options.bgmode = "true";
    this.kag.stat.current_bgmovie["storage"] = options.storage;
    this.kag.stat.current_bgmovie["volume"] = options.volume;
    if (this.kag.tmp.video_playing != false) {
      /** @type {(HTMLElement|null)} */
      var o = document.getElementById("bgmovie");
      /** @type {Object} */
      this.kag.stat.video_stack = options;
      /** @type {boolean} */
      o.loop = false;
      return;
    }
    this.kag.ftag.startTag("movie", options);
    if (options.stop == "false") {
      this.kag.ftag.nextOrder();
    }
  }
};
tyrano.plugin.kag.tag.wait_bgmovie = {
  vital : [],
  pm : {
    stop : "false"
  },
  /**
   * @param {?} ui
   * @return {undefined}
   */
  start : function(ui) {
    var that = this;
    if (this.kag.tmp.video_playing == true) {
      /** @type {(HTMLElement|null)} */
      var o = document.getElementById("bgmovie");
      /** @type {boolean} */
      this.kag.stat.is_wait_bgmovie = true;
      /** @type {boolean} */
      o.loop = false;
    } else {
      this.kag.ftag.nextOrder();
    }
  }
};
tyrano.plugin.kag.tag.stop_bgmovie = {
  vital : [],
  pm : {},
  /**
   * @param {?} ui
   * @return {undefined}
   */
  start : function(ui) {
    var that = this;
    /** @type {boolean} */
    that.kag.tmp.video_playing = false;
    /** @type {string} */
    that.kag.stat.current_bgmovie["storage"] = "";
    /** @type {string} */
    that.kag.stat.current_bgmovie["volume"] = "";
    $(".tyrano_base").find("video").remove();
    that.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.showsave = {
  pm : {},
  /**
   * @param {?} ui
   * @return {undefined}
   */
  start : function(ui) {
    this.kag.menu.displaySave();
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.showload = {
  pm : {},
  /**
   * @param {?} ui
   * @return {undefined}
   */
  start : function(ui) {
    this.kag.menu.displayLoad();
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.showconfig = {
  pm : {},
  /**
   * @param {?} ui
   * @return {undefined}
   */
  start : function(ui) {
    this.kag.menu.displayConfig();
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.showmenu = {
  pm : {},
  /**
   * @param {?} ui
   * @return {undefined}
   */
  start : function(ui) {
    this.kag.menu.showMenu();
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.showmenubutton = {
  pm : {},
  /**
   * @param {?} ui
   * @return {undefined}
   */
  start : function(ui) {
    $(".button_menu").show();
    /** @type {boolean} */
    this.kag.stat.visible_menu_button = true;
    /** @type {string} */
    this.kag.config.configVisible = "true";
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.hidemenubutton = {
  pm : {},
  /**
   * @param {?} ui
   * @return {undefined}
   */
  start : function(ui) {
    $(".button_menu").hide();
    /** @type {boolean} */
    this.kag.stat.visible_menu_button = false;
    /** @type {string} */
    this.kag.config.configVisible = "false";
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.skipstart = {
  pm : {},
  /**
   * @param {?} ui
   * @return {?}
   */
  start : function(ui) {
    if (this.kag.stat.is_skip == true) {
      return false;
    }
    /** @type {boolean} */
    this.kag.stat.is_skip = true;
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.skipstop = {
  pm : {},
  /**
   * @param {?} ui
   * @return {undefined}
   */
  start : function(ui) {
    /** @type {boolean} */
    this.kag.stat.is_skip = false;
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.autostart = {
  pm : {},
  /**
   * @param {?} ui
   * @return {?}
   */
  start : function(ui) {
    if (this.kag.stat.is_auto == true) {
      return false;
    }
    /** @type {boolean} */
    this.kag.stat.is_auto = true;
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.autostop = {
  pm : {},
  /**
   * @param {?} ui
   * @return {undefined}
   */
  start : function(ui) {
    /** @type {boolean} */
    this.kag.stat.is_auto = false;
    /** @type {boolean} */
    this.kag.stat.is_wait_auto = false;
  }
};
tyrano.plugin.kag.tag.autoconfig = {
  pm : {
    speed : "",
    clickstop : ""
  },
  /**
   * @param {Object} attrs
   * @return {undefined}
   */
  start : function(attrs) {
    if (attrs.speed != "") {
      this.kag.config.autoSpeed = attrs.speed;
      this.kag.ftag.startTag("eval", {
        "exp" : "sf._system_config_auto_speed = " + attrs.speed
      });
    }
    if (attrs.clickstop != "") {
      this.kag.config.autoClickStop = attrs.clickstop;
      this.kag.ftag.startTag("eval", {
        "exp" : "sf._system_config_auto_click_stop = " + attrs.clickstop
      });
    }
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.anim = {
  pm : {
    name : "",
    layer : "",
    left : "",
    top : "",
    width : "",
    height : "",
    opacity : "",
    color : "",
    time : "2000",
    effect : ""
  },
  /**
   * @param {Object} pm
   * @return {undefined}
   */
  start : function(pm) {
    var that = this;
    var anim_style = {};
    if (pm.left != "") {
      anim_style.left = pm.left;
    }
    if (pm.top != "") {
      anim_style.top = pm.top;
    }
    if (pm.width != "") {
      anim_style.width = pm.width;
    }
    if (pm.height != "") {
      anim_style.height = pm.height;
    }
    if (pm.opacity != "") {
      anim_style.opacity = $.convertOpacity(pm.opacity);
    }
    if (pm.color != "") {
      anim_style.color = $.convertColor(pm.color);
    }
    /** @type {string} */
    var optsData = "";
    if (pm.name != "") {
      that.kag.pushAnimStack();
      $("." + pm.name).animate(anim_style, parseInt(pm.time), pm.effect, function() {
        that.kag.popAnimStack();
      });
    } else {
      if (pm.layer != "") {
        /** @type {string} */
        var layer_name = pm.layer + "_fore";
        if (pm.layer == "free") {
          /** @type {string} */
          layer_name = "layer_free";
        }
        var cursor = $("." + layer_name).children();
        cursor.each(function() {
          that.kag.pushAnimStack();
          $(this).animate(anim_style, parseInt(pm.time), pm.effect, function() {
            that.kag.popAnimStack();
          });
        });
      }
    }
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.wa = {
  /**
   * @param {?} ui
   * @return {undefined}
   */
  start : function(ui) {
    if (this.kag.tmp.num_anim > 0) {
      this.kag.layer.hideEventLayer();
    } else {
      this.kag.ftag.nextOrder();
    }
  }
};
tyrano.plugin.kag.tag.stopanim = {
  vital : ["name"],
  pm : {
    name : ""
  },
  /**
   * @param {Function} ui
   * @return {undefined}
   */
  start : function(ui) {
    $("." + ui.name).stop();
    this.kag.popAnimStack();
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.keyframe = {
  vital : ["name"],
  pm : {
    name : ""
  },
  /**
   * @param {Function} pm
   * @return {undefined}
   */
  start : function(pm) {
    this.kag.stat.current_keyframe = pm.name;
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.endkeyframe = {
  pm : {},
  /**
   * @param {?} ui
   * @return {undefined}
   */
  start : function(ui) {
    /** @type {string} */
    this.kag.stat.current_keyframe = "";
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.frame = {
  vital : ["p"],
  pm : {
    p : ""
  },
  master_trans : {
    "x" : "",
    "y" : "",
    "z" : "",
    "translate" : "",
    "translate3d" : "",
    "translateX" : "",
    "translateY" : "",
    "translateZ" : "",
    "scale" : "",
    "scale3d" : "",
    "scaleX" : "",
    "scaleY" : "",
    "scaleZ" : "",
    "rotate" : "",
    "rotate3d" : "",
    "rotateX" : "",
    "rotateY" : "",
    "rotateZ" : "",
    "skew" : "",
    "skewX" : "",
    "skewY" : "",
    "perspective" : ""
  },
  /**
   * @param {Object} pm
   * @return {undefined}
   */
  start : function(pm) {
    var percentage = pm.p;
    delete pm.p;
    if (this.kag.stat.map_keyframe[this.kag.stat.current_keyframe]) {
    } else {
      this.kag.stat.map_keyframe[this.kag.stat.current_keyframe] = {};
      this.kag.stat.map_keyframe[this.kag.stat.current_keyframe]["frames"] = {};
      this.kag.stat.map_keyframe[this.kag.stat.current_keyframe]["styles"] = {};
    }
    var map_trans = {};
    var map_style = {};
    for (key in pm) {
      if (this.master_trans[key] == "") {
        map_trans[key] = pm[key];
      } else {
        map_style[key] = pm[key];
      }
    }
    this.kag.stat.map_keyframe[this.kag.stat.current_keyframe]["frames"][percentage] = {
      "trans" : map_trans,
      "styles" : map_style
    };
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.kanim = {
  vital : ["keyframe"],
  pm : {
    "name" : "",
    "layer" : "",
    "keyframe" : ""
  },
  /**
   * @param {Object} pm
   * @return {undefined}
   */
  start : function(pm) {
    var that = this;
    var anim = this.kag.stat.map_keyframe[pm.keyframe];
    /** @type {string} */
    var class_name = "." + pm.name;
    /** @type {Object} */
    anim.config = pm;
    if (pm.time) {
      /** @type {string} */
      pm.duration = parseInt(pm.time) + "ms";
    }
    /**
     * @return {undefined}
     */
    anim.complete = function() {
      that.kag.popAnimStack();
    };
    if (pm.name != "") {
      delete pm.name;
      delete pm.keyframe;
      that.kag.pushAnimStack();
      $(class_name).a3d(anim);
    } else {
      if (pm.layer != "") {
        /** @type {string} */
        var layer_name = pm.layer + "_fore";
        if (pm.layer == "free") {
          /** @type {string} */
          layer_name = "layer_free";
        }
        delete pm.name;
        delete pm.keyframe;
        delete pm.layer;
        var cursor = $("." + layer_name).children();
        cursor.each(function() {
          that.kag.pushAnimStack();
          $(this).a3d(anim);
        });
      }
    }
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.chara_ptext = {
  pm : {
    name : "",
    face : ""
  },
  /**
   * @param {Object} pm
   * @return {undefined}
   */
  start : function(pm) {
    if (pm.name == "") {
      $("." + this.kag.stat.chara_ptext).html("");
      if (this.kag.stat.chara_talk_focus != "none") {
        $("#tyrano_base").find(".tyrano_chara").css({
          "-webkit-filter" : this.kag.stat.apply_filter_str,
          "-ms-filter" : this.kag.stat.apply_filter_str,
          "-moz-filter" : this.kag.stat.apply_filter_str
        });
      }
    } else {
      var element = this.kag.stat.charas[pm.name];
      if (element) {
        $("." + this.kag.stat.chara_ptext).html(element.jname);
        if (element.color != "") {
          $("." + this.kag.stat.chara_ptext).css("color", $.convertColor(element.color));
        }
        if (this.kag.stat.chara_talk_focus != "none") {
          $("#tyrano_base").find(".tyrano_chara").css({
            "-webkit-filter" : this.kag.stat.apply_filter_str,
            "-ms-filter" : this.kag.stat.apply_filter_str,
            "-moz-filter" : this.kag.stat.apply_filter_str
          });
          $("#tyrano_base").find("." + pm.name + ".tyrano_chara").css({
            "-webkit-filter" : "brightness(100%) blur(0px)",
            "-ms-filter" : "brightness(100%) blur(0px)",
            "-moz-filter" : "brightness(100%) blur(0px)"
          });
        }
      } else {
        if(pm.name == "f.main_char_name") {
          $("." + this.kag.stat.chara_ptext).html(this.kag.stat.f.main_char_name);
        } else {
          $("." + this.kag.stat.chara_ptext).html(pm.name);
        }
      }
    }
    if (pm.face != "") {
      if (!this.kag.stat.charas[pm.name]["map_face"][pm.face]) {
        this.kag.error("\u6307\u5b9a\u3055\u308c\u305f\u30ad\u30e3\u30e9\u30af\u30bf\u30fc\u300c" + pm.name + "\u300d\u3082\u3057\u304f\u306fface:\u300c" + pm.face + "\u300d\u306f\u5b9a\u7fa9\u3055\u308c\u3066\u3044\u307e\u305b\u3093\u3002\u3082\u3046\u4e00\u5ea6\u78ba\u8a8d\u3092\u304a\u9858\u3044\u3057\u307e\u3059");
        return;
      }
      var imageData = this.kag.stat.charas[pm.name]["map_face"][pm.face];
      $("." + pm.name).attr("src", "./data/fgimage/" + imageData);
    }
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.chara_config = {
  pm : {
    pos_mode : "",
    effect : "",
    ptext : "",
    time : "",
    memory : "",
    anim : "",
    pos_change_time : "",
    talk_focus : "",
    brightness_value : "",
    blur_value : ""
  },
  /**
   * @param {Object} pm
   * @return {undefined}
   */
  start : function(pm) {
    if (pm.pos_mode != "") {
      this.kag.stat.chara_pos_mode = pm.pos_mode;
    }
    if (pm.effect != "") {
      this.kag.stat.chara_effect = pm.effect;
    }
    if (pm.ptext != "") {
      this.kag.stat.chara_ptext = pm.ptext;
    }
    if (pm.time != "") {
      this.kag.stat.chara_time = pm.time;
    }
    if (pm.memory != "") {
      this.kag.stat.chara_memory = pm.memory;
    }
    if (pm.anim != "") {
      this.kag.stat.chara_anim = pm.anim;
    }
    if (pm.pos_change_time != "") {
      this.kag.stat.pos_change_time = pm.pos_change_time;
    }
    if (pm.brightness_value != "") {
      this.kag.stat.chara_brightness_value = pm.brightness_value;
    }
    if (pm.blur_value != "") {
      this.kag.stat.chara_blur_value = pm.blur_value;
    }
    if (pm.talk_focus != "") {
      if (pm.talk_focus == "none") {
        /** @type {string} */
        this.kag.stat.apply_filter_str = "";
      } else {
        if (pm.talk_focus == "brightness") {
          /** @type {string} */
          this.kag.stat.apply_filter_str = "brightness(" + this.kag.stat.chara_brightness_value + "%)";
        } else {
          if (pm.talk_focus == "blur") {
            /** @type {string} */
            this.kag.stat.apply_filter_str = "blur(" + this.kag.stat.chara_blur_value + "px)";
          }
        }
      }
      $("#tyrano_base").find(".tyrano_chara").css({
        "-webkit-filter" : "brightness(100%) blur(0px)",
        "-ms-filter" : "brightness(100%) blur(0px)",
        "-moz-filter" : "brightness(100%) blur(0px)"
      });
      this.kag.stat.chara_talk_focus = pm.talk_focus;
    }
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.chara_new = {
  vital : ["name", "storage"],
  pm : {
    name : "",
    storage : "",
    width : "",
    height : "",
    reflect : "false",
    jname : "",
    visible : "false",
    color : "",
    map_face : {}
  },
  /**
   * @param {Object} pm
   * @return {undefined}
   */
  start : function(pm) {
    /** @type {string} */
    var storage_url = "./data/fgimage/" + pm.storage;
    if ($.isHTTP(pm.storage)) {
      storage_url = pm.storage;
    }
    pm.map_face["default"] = pm.storage;
    this.kag.preload(storage_url);
    if (pm.visible == "true") {
    }
    /** @type {Object} */
    this.kag.stat.charas[pm.name] = pm;
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.chara_show = {
  vital : ["name"],
  pm : {
    name : "",
    page : "fore",
    layer : "0",
    wait : "true",
    left : "0",
    top : "0",
    width : "",
    height : "",
    zindex : "",
    reflect : "",
    face : "",
    time : 1E3
  },
  /**
   * @param {Object} pm
   * @return {undefined}
   */
  start : function(pm) {
    var that = this;
    var data = this.kag.stat.charas[pm.name];
    if (data == null) {
      this.kag.error("\u6307\u5b9a\u3055\u308c\u305f\u30ad\u30e3\u30e9\u30af\u30bf\u30fc\u300c" + pm.name + "\u300d\u306f\u5b9a\u7fa9\u3055\u308c\u3066\u3044\u307e\u305b\u3093\u3002[chara_new]\u3067\u5b9a\u7fa9\u3057\u3066\u304f\u3060\u3055\u3044");
      return;
    }
    var cl = $(".layer_" + pm.page).find("." + pm.name);
    if (cl.get(0)) {
      that.kag.ftag.nextOrder();
      return;
    }
    /** @type {string} */
    var storage_url = "./data/fgimage/" + data.storage;
    if ($.isHTTP(data.storage)) {
      storage_url = data.storage;
    }
    if (pm.face != "") {
      if (!data["map_face"][pm.face]) {
        this.kag.error("\u6307\u5b9a\u3055\u308c\u305f\u30ad\u30e3\u30e9\u30af\u30bf\u30fc\u300c" + pm.name + "\u300d\u3082\u3057\u304f\u306fface:\u300c" + pm.face + "\u300d\u306f\u5b9a\u7fa9\u3055\u308c\u3066\u3044\u307e\u305b\u3093\u3002\u3082\u3046\u4e00\u5ea6\u78ba\u8a8d\u3092\u304a\u9858\u3044\u3057\u307e\u3059");
        return;
      }
      storage_url = "./data/fgimage/" + data["map_face"][pm.face];
    }
    var img_obj = $("<img />");
    img_obj.attr("src", storage_url);
    img_obj.css("position", "absolute");
    img_obj.css("display", "none");
    if (pm.width != "") {
      /** @type {number} */
      var newVal = parseInt(pm.width);
      /** @type {number} */
      data.width = newVal;
    }
    if (pm.height != "") {
      /** @type {number} */
      var total = parseInt(pm.height);
      /** @type {number} */
      data.height = total;
    }
    if (pm.zindex != "") {
      /** @type {number} */
      var minWidth = parseInt(pm.zindex);
      img_obj.css("z-index", minWidth);
    }
    if (pm.reflect != "") {
      if (pm.reflect == "true") {
        /** @type {string} */
        data.reflect = "true";
      } else {
        /** @type {string} */
        data.reflect = "false";
      }
    }
    this.kag.preload(storage_url, function() {
      var target_layer = that.kag.layer.getLayer(pm.layer, pm.page);
      target_layer.append(img_obj).show();
      /** @type {number} */
      var chara_num = 1;
      that.kag.layer.hideEventLayer();
      if (that.kag.stat.chara_pos_mode == "true" && (pm.top == "0" && pm.left == "0")) {
        img_obj.css("bottom", "0px");
        var chara_cnt = target_layer.find(".tyrano_chara").length;
        /** @type {number} */
        var sc_width = parseInt(that.kag.config.scWidth);
        /** @type {number} */
        var charCodeToReplace = parseInt(that.kag.config.scHeight);
        /** @type {number} */
        var center = Math.floor(parseInt(img_obj.css("width")) / 2);
        /** @type {number} */
        var base = Math.floor(sc_width / (chara_cnt + 2));
        /** @type {number} */
        var tmp_base = base;
        /** @type {number} */
        var first_left = base - center;
        img_obj.css("left", first_left + "px");
        var formIds = target_layer.find(".tyrano_chara").get().reverse();
        $(formIds).each(function() {
          chara_num++;
          tmp_base += base;
          var self = $(this);
          /** @type {number} */
          center = Math.floor(parseInt(self.css("width")) / 2);
          /** @type {number} */
          var left = tmp_base - center;
          if (that.kag.stat.chara_anim == "false") {
            self.fadeTo(parseInt(pm.time), 0, function() {
              self.css("left", left);
              self.fadeTo(parseInt(that.kag.stat.pos_change_time), 1, function() {
                chara_num--;
                if (chara_num == 0) {
                  that.kag.layer.showEventLayer();
                  that.kag.ftag.nextOrder();
                }
              });
            });
          } else {
            self.animate({
              left : left
            }, parseInt(that.kag.stat.pos_change_time), that.kag.stat.chara_effect, function() {
              chara_num--;
              if (chara_num == 0) {
                that.kag.layer.showEventLayer();
                that.kag.ftag.nextOrder();
              }
            });
          }
        });
      } else {
        img_obj.css("top", pm.top + "px");
        img_obj.css("left", pm.left + "px");
      }
      $.setName(img_obj, data.name);
      img_obj.addClass("tyrano_chara");
      if (data.width != "") {
        img_obj.css("width", data.width + "px");
      }
      if (data.height != "") {
        img_obj.css("height", data.height + "px");
      }
      if (data.reflect == "true") {
        img_obj.addClass("reflect");
      } else {
        img_obj.removeClass("reflect");
      }
      if (pm.wait != "true") {
        that.kag.ftag.nextOrder();
      }
      img_obj.animate({
        opacity : "show"
      }, {
        duration : parseInt(pm.time),
        easing : that.kag.stat.chara_effect,
        /**
         * @return {undefined}
         */
        complete : function() {
          chara_num--;
          if (chara_num == 0) {
            that.kag.layer.showEventLayer();
            if (pm.wait == "true") {
              that.kag.ftag.nextOrder();
            }
          }
        }
      });
    });
  }
};
tyrano.plugin.kag.tag.chara_hide = {
  vital : ["name"],
  pm : {
    page : "fore",
    layer : "0",
    name : "",
    wait : "true",
    pos_mode : "true",
    time : "1000"
  },
  /**
   * @param {Object} pm
   * @return {undefined}
   */
  start : function(pm) {
    var that = this;
    var rule = this.kag.layer.getLayer(pm.layer, pm.page);
    var img_obj = rule.find("." + pm.name);
    /** @type {number} */
    var chara_num = 0;
    that.kag.layer.hideEventLayer();
    img_obj.animate({
      opacity : "hide"
    }, {
      duration : parseInt(pm.time),
      easing : "linear",
      /**
       * @return {undefined}
       */
      complete : function() {
        img_obj.remove();
        if (that.kag.stat.chara_pos_mode == "true" && pm.pos_mode == "true") {
          var chara_cnt = rule.find(".tyrano_chara").length;
          /** @type {number} */
          var sc_width = parseInt(that.kag.config.scWidth);
          /** @type {number} */
          var charCodeToReplace = parseInt(that.kag.config.scHeight);
          /** @type {number} */
          var base = Math.floor(sc_width / (chara_cnt + 1));
          /** @type {number} */
          var tmp_base = 0;
          if (chara_cnt == 0) {
            that.kag.layer.showEventLayer();
            that.kag.ftag.nextOrder();
            return;
          }
          var formIds = rule.find(".tyrano_chara").get().reverse();
          $(formIds).each(function() {
            chara_num++;
            tmp_base += base;
            var self = $(this);
            /** @type {number} */
            var center = Math.floor(parseInt(self.css("width")) / 2);
            /** @type {number} */
            var left = tmp_base - center;
            if (that.kag.stat.chara_anim == "false") {
              self.fadeTo(parseInt(pm.time), 0, function() {
                self.css("left", left);
                self.fadeTo(parseInt(that.kag.stat.pos_change_time), 1, function() {
                  chara_num--;
                  if (chara_num == 0) {
                    that.kag.layer.showEventLayer();
                    that.kag.ftag.nextOrder();
                  }
                });
              });
            } else {
              self.animate({
                left : left
              }, parseInt(that.kag.stat.pos_change_time), that.kag.stat.chara_effect, function() {
                chara_num--;
                if (chara_num == 0) {
                  that.kag.layer.showEventLayer();
                  that.kag.ftag.nextOrder();
                }
              });
            }
          });
        } else {
          if (pm.wait == "true") {
            that.kag.layer.showEventLayer();
            that.kag.ftag.nextOrder();
          }
        }
      }
    });
    if (this.kag.stat.chara_memory == "false") {
      this.kag.stat.charas[pm.name].storage = this.kag.stat.charas[pm.name]["map_face"]["default"];
    }
    if (pm.wait != "true") {
      this.kag.ftag.nextOrder();
    }
  }
};
tyrano.plugin.kag.tag.chara_hide_all = {
  vital : [],
  pm : {
    page : "fore",
    layer : "0",
    wait : "true",
    time : "1000"
  },
  /**
   * @param {Object} pm
   * @return {undefined}
   */
  start : function(pm) {
    var that = this;
    var rule = this.kag.layer.getLayer(pm.layer, pm.page);
    var img_obj = rule.find(".tyrano_chara");
    /** @type {number} */
    var chara_num = 0;
    that.kag.layer.hideEventLayer();
    /** @type {boolean} */
    var flag_complete = false;
    img_obj.animate({
      opacity : "hide"
    }, {
      duration : parseInt(pm.time),
      easing : "linear",
      /**
       * @return {undefined}
       */
      complete : function() {
        img_obj.remove();
        if (pm.wait == "true") {
          if (flag_complete == false) {
            /** @type {boolean} */
            flag_complete = true;
            that.kag.layer.showEventLayer();
            that.kag.ftag.nextOrder();
          }
        }
      }
    });
    if (this.kag.stat.chara_memory == "false") {
      for (key in this.kag.stat.charas) {
        this.kag.stat.charas[key].storage = this.kag.stat.charas[key]["map_face"]["default"];
      }
    }
    if (pm.wait != "true") {
      this.kag.layer.showEventLayer();
      this.kag.ftag.nextOrder();
    }
  }
};
tyrano.plugin.kag.tag.chara_delete = {
  vital : ["name"],
  pm : {
    name : ""
  },
  /**
   * @param {Function} pm
   * @return {undefined}
   */
  start : function(pm) {
    delete this.kag.stat.charas[pm.name];
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.chara_mod = {
  vital : ["name"],
  pm : {
    name : "",
    face : "",
    reflect : "",
    storage : "",
    time : ""
  },
  /**
   * @param {Object} pm
   * @return {undefined}
   */
  start : function(pm) {
    var that = this;
    /** @type {string} */
    var type = "";
    if (pm.face != "") {
      if (!this.kag.stat.charas[pm.name]["map_face"][pm.face]) {
        this.kag.error("\u6307\u5b9a\u3055\u308c\u305f\u30ad\u30e3\u30e9\u30af\u30bf\u30fc\u300c" + pm.name + "\u300d\u3082\u3057\u304f\u306fface:\u300c" + pm.face + "\u300d\u306f\u5b9a\u7fa9\u3055\u308c\u3066\u3044\u307e\u305b\u3093\u3002\u3082\u3046\u4e00\u5ea6\u78ba\u8a8d\u3092\u304a\u9858\u3044\u3057\u307e\u3059");
        return;
      }
      type = this.kag.stat.charas[pm.name]["map_face"][pm.face];
    } else {
      if ($.isHTTP(pm.storage)) {
        type = pm.storage;
      } else {
        type = pm.storage;
      }
    }
    if ($(".layer_fore").find("." + pm.name).size() == 0) {
      this.kag.stat.charas[pm.name]["storage"] = type;
      this.kag.stat.charas[pm.name]["reflect"] = pm.reflect;
      this.kag.ftag.nextOrder();
      return;
    }
    var cDigit = this.kag.stat.chara_time;
    if (pm.time != "") {
      cDigit = pm.time;
    }
    if ($(".layer_fore").find("." + pm.name).attr("src") == "./data/fgimage/" + type) {
      /** @type {string} */
      cDigit = "0";
    }
    if (pm.reflect != "") {
      if (pm.reflect == "true") {
        $(".layer_fore").find("." + pm.name).addClass("reflect");
      } else {
        $(".layer_fore").find("." + pm.name).removeClass("reflect");
      }
      this.kag.stat.charas[pm.name]["reflect"] = pm.reflect;
    }
    if (type == "") {
      this.kag.ftag.nextOrder();
      return;
    }
    if (cDigit != "0") {
      var wrapper = $(".layer_fore").find("." + pm.name).clone();
      wrapper.attr("src", "./data/fgimage/" + type);
      wrapper.css("opacity", 0);
      var self = $(".layer_fore").find("." + pm.name);
      self.after(wrapper);
      self.fadeTo(parseInt(cDigit), 0, function() {
      });
      wrapper.fadeTo(parseInt(cDigit), 1, function() {
        self.remove();
        that.kag.ftag.nextOrder();
      });
    } else {
      $(".layer_fore").find("." + pm.name).attr("src", "./data/fgimage/" + type);
      this.kag.ftag.nextOrder();
    }
    this.kag.stat.charas[pm.name]["storage"] = type;
  }
};
tyrano.plugin.kag.tag.chara_move = {
  vital : ["name"],
  pm : {
    page : "fore",
    layer : "0",
    name : "",
    wait : "true",
    pos_mode : "true",
    time : "1000"
  },
  /**
   * @param {Object} pm
   * @return {undefined}
   */
  start : function(pm) {
    var that = this;
    var rule = this.kag.layer.getLayer(pm.layer, pm.page);
    var img_obj = rule.find("." + pm.name);
    that.kag.layer.hideEventLayer();
    img_obj.animate({
      left : pm.left
    }, {
      duration : parseInt(pm.time),
      easing : "linear",
      /**
       * @return {undefined}
       */
      complete : function() {
          if (pm.wait == "true") {
            that.kag.layer.showEventLayer();
            that.kag.ftag.nextOrder();
          }
      }
    });
    if (pm.wait != "true") {
      this.kag.ftag.nextOrder();
    }
  }
};
tyrano.plugin.kag.tag.chara_order = {
  vital : ["name"],
  pm : {
    page : "fore",
    layer : "0",
    name : "",
    zindex : "",
    time : "1000"
  },
  /**
   * @param {Object} pm
   * @return {undefined}
   */
  start : function(pm) {
    var that = this;
    var rule = this.kag.layer.getLayer(pm.layer, pm.page);
    var img_obj = rule.find("." + pm.name);
    that.kag.layer.hideEventLayer();
    var minWidth = parseInt(pm.zindex);
    img_obj.css("z-index", minWidth);
    that.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.chara_face = {
  vital : ["name", "face", "storage"],
  pm : {
    name : "",
    face : "",
    storage : ""
  },
  /**
   * @param {Object} pm
   * @return {undefined}
   */
  start : function(pm) {
    /** @type {string} */
    var storage_url = "";
    if ($.isHTTP(pm.storage)) {
      storage_url = pm.storage;
    } else {
      storage_url = pm.storage;
    }
    this.kag.stat.charas[pm.name]["map_face"][pm.face] = storage_url;
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.showlog = {
  pm : {},
  /**
   * @param {?} ui
   * @return {undefined}
   */
  start : function(ui) {
    this.kag.menu.displayLog();
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.message_on = {
  pm: {},
  start: function (pm) {
    $(".message0_fore").css("display", "");
    $(".message0_fore").attr("l_visible", "true");
    this.kag.config.configVisible = "true";
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.message_off = {
  pm: {},
  start: function (pm) {
    $(".button_menu").hide();
    this.kag.config.configVisible = "false";
    $(".chara_name_area").html("");
    $(".message0_fore").css("display", "none");
    $(".message0_fore").attr("l_visible", "false");
    this.kag.ftag.nextOrder();
  }
};

