tyrano.plugin.kag.tag.eval = {
  vital : ["exp"],
  pm : {
    exp : ""
  },
  /**
   * @param {Array} scope
   * @return {undefined}
   */
  start : function(scope) {
    this.kag.evalScript(scope.exp);
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.clearvar = {
  pm : {},
  /**
   * @param {?} ui
   * @return {undefined}
   */
  start : function(ui) {
    this.kag.clearVariable();
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.clearsysvar = {
  /**
   * @return {undefined}
   */
  start : function() {
    this.kag.variable.sf = {};
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.clearstack = {
  pm : {
    stack : ""
  },
  /**
   * @param {?} e
   * @return {undefined}
   */
  start : function(e) {
    if (e.stack == "") {
      this.kag.stat.stack = {
        "if" : [],
        "call" : [],
        "macro" : []
      };
    } else {
      /** @type {Array} */
      this.kag.stat.stack[e.stack] = [];
    }
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag["close"] = {
  pm : {
    ask : "true"
  },
  /**
   * @param {?} args
   * @return {undefined}
   */
  start : function(args) {
    var that = this;
    if (args.ask == "true") {
      var ele = this.kag.layer.getFreeLayer();
      ele.css("z-index", 999999);
      var el = $("<img />");
      el.attr("src", 'tyrano/images/kag/closeback.png');
      el.css("position", "absolute");
      el.css("z-index", 99999999);
      el.show();
      el.css("left", 170 + "px");
      el.css("top", 120 + "px");
      $.setName(el, 'testconfirm');
      ele.append(el);

      var yes = $("<img />");
      yes.attr("src", 'tyrano/images/kag/yes.png');
      yes.css("position", "absolute");
      yes.css("cursor", "pointer");
      yes.css("z-index", 999999999);
      yes.show();
      yes.css("left", (170 + 95) + "px");
      yes.css("top", (120 + 115) + "px");
      $.setName(yes, 'yes');
      yes.click(function(event) {
          that.close();
      });
      ele.append(yes);

      var no = $("<img />");
      no.attr("src", 'tyrano/images/kag/no.png');
      no.css("position", "absolute");
      no.css("cursor", "pointer");
      no.css("z-index", 999999999);
      no.show();
      no.css("left", (170 + 250) + "px");
      no.css("top", (120 + 115) + "px");
      $.setName(no, 'no');
      no.click(function(event) {
          that.kag.ftag.nextOrder();
          el.remove();
          yes.remove();
          no.remove();
      });
      ele.append(no);

      ele.show();

//      $.confirm($.lang("exit_game"), function() {
//        that.close();
//      }, function() {
//        that.kag.ftag.nextOrder();
//      });
    } else {
      this.close();
    }
  },
  /**
   * @return {undefined}
   */
  close : function() {
    window.close();
    if (typeof navigator.app != "undefined") {
      navigator.app.exitApp();
    }
    if (typeof require != "undefined" && typeof require("nw.gui") != "undefined") {
      require("nw.gui").Window.get().close();
    }
  }
};
tyrano.plugin.kag.tag["trace"] = {
  pm : {
    exp : ""
  },
  /**
   * @param {Array} scope
   * @return {undefined}
   */
  start : function(scope) {
    var reply = this.kag.embScript(scope.exp);
    this.kag.log("trace\u51fa\u529b\uff1a" + reply);
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag["title"] = {
  vital : ["name"],
  pm : {
    name : ""
  },
  /**
   * @param {Function} config
   * @return {undefined}
   */
  start : function(config) {
    if (config.name != "") {
      this.kag.setTitle(config.name);
      this.kag.ftag.nextOrder();
    }
  }
};
tyrano.plugin.kag.tag.iscript = {
  /**
   * @param {?} ui
   * @return {undefined}
   */
  start : function(ui) {
    /** @type {boolean} */
    this.kag.stat.is_script = true;
    /** @type {string} */
    this.kag.stat.buff_script = "";
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.endscript = {
  pm : {
    stop : "false"
  },
  /**
   * @param {Object} pm
   * @return {undefined}
   */
  start : function(pm) {
    /** @type {boolean} */
    this.kag.stat.is_script = false;
    this.kag.evalScript(this.kag.stat.buff_script);
    /** @type {string} */
    this.kag.stat.buff_script = "";
    if (pm.stop == "false") {
      this.kag.ftag.nextOrder();
    }
  }
};
tyrano.plugin.kag.tag.html = {
  pm : {
    layer : "",
    top : 0,
    left : 0
  },
  /**
   * @param {Object} ui
   * @return {undefined}
   */
  start : function(ui) {
    /** @type {boolean} */
    this.kag.stat.is_html = true;
    this.kag.stat.map_html = {};
    /** @type {string} */
    this.kag.stat.map_html.buff_html = "";
    /** @type {Object} */
    this.kag.stat.map_html.buff_pm = ui;
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.endhtml = {
  /**
   * @param {?} ui
   * @return {undefined}
   */
  start : function(ui) {
    var that = this;
    var cfg = this.kag.stat.map_html.buff_pm;
    var span = this.kag.stat.map_html.buff_html;
    var wrapper = $("<div></div>");
    wrapper.css("position", "absolute");
    wrapper.css("top", cfg.top + "px");
    wrapper.css("left", cfg.left + "px");
    $.setName(wrapper, cfg.name);
    wrapper.append($(span));
    var el = this.kag.layer.getFreeLayer();
    el.css("z-index", 9999999);
    el.append(wrapper);
    el.show();
    /** @type {boolean} */
    this.kag.stat.is_html = false;
    this.kag.stat.map_html = {};
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.emb = {
  vital : ["exp"],
  pm : {
    exp : ""
  },
  /**
   * @param {Array} scope
   * @return {undefined}
   */
  start : function(scope) {
    var n = "" + this.kag.embScript(scope.exp);
    this.kag.ftag.startTag("text", {
      "val" : n
    });
  }
};
tyrano.plugin.kag.tag["if"] = {
  vital : ["exp"],
  pm : {
    "exp" : ""
  },
  /**
   * @param {Array} scope
   * @return {undefined}
   */
  start : function(scope) {
    if (this.kag.embScript(scope.exp)) {
      this.kag.pushStack("if", true);
      this.kag.ftag.nextOrder();
    } else {
      this.kag.pushStack("if", false);
      /** @type {number} */
      var i = 0;
      for (;i < 2E3;i++) {
        var r = this.kag.ftag.nextOrderWithTag({
          "else" : "",
          "elsif" : "",
          "endif" : ""
        });
        if (r == true) {
          break;
        }
      }
      if (i > 1900) {
        this.kag.error("If\u6587\u306b\u8aa4\u308a\u304c\u3042\u308a\u307e\u3059");
      }
    }
  }
};
tyrano.plugin.kag.tag["elsif"] = {
  vital : ["exp"],
  pm : {
    "exp" : ""
  },
  /**
   * @param {Array} scope
   * @return {undefined}
   */
  start : function(scope) {
    if (this.kag.getStack("if") == false && this.kag.embScript(scope.exp)) {
      this.kag.setStack("if", true);
      this.kag.ftag.nextOrder();
    } else {
      /** @type {number} */
      var i = 0;
      for (;i < 2E3;i++) {
        var r = this.kag.ftag.nextOrderWithTag({
          "else" : "",
          "elsif" : "",
          "endif" : ""
        });
        if (r == true) {
          break;
        }
      }
      if (i > 1900) {
        this.kag.error("If\u6587\u306b\u8aa4\u308a\u304c\u3042\u308a\u307e\u3059");
      }
    }
  }
};
tyrano.plugin.kag.tag["else"] = {
  pm : {
    "exp" : ""
  },
  /**
   * @param {?} ui
   * @return {undefined}
   */
  start : function(ui) {
    if (this.kag.getStack("if") == false) {
      this.kag.setStack("if", true);
      this.kag.ftag.nextOrder();
    } else {
      /** @type {number} */
      var i = 0;
      for (;i < 2E3;i++) {
        var r = this.kag.ftag.nextOrderWithTag({
          "endif" : ""
        });
        if (r == true) {
          break;
        }
      }
      if (i > 1900) {
        this.kag.error("If\u6587\u306b\u8aa4\u308a\u304c\u3042\u308a\u307e\u3059");
      }
    }
  }
};
tyrano.plugin.kag.tag["endif"] = {
  /**
   * @return {undefined}
   */
  start : function() {
    this.kag.popStack("if");
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag["call"] = {
  pm : {
    storage : null,
    target : null,
    countpage : true,
    auto_next : "yes"
  },
  /**
   * @param {Object} pm
   * @return {undefined}
   */
  start : function(pm) {
    var data = {};
    data.index = this.kag.ftag.current_order_index;
    data.storage = this.kag.stat.current_scenario;
    data.auto_next = pm.auto_next;
    this.kag.pushStack("call", data);
    if (pm.target == null && pm.storage != null) {
      this.kag.ftag.nextOrderWithIndex(-1, pm.storage);
    } else {
      this.kag.ftag.nextOrderWithLabel(pm.target, pm.storage);
    }
  }
};
tyrano.plugin.kag.tag["return"] = {
  /**
   * @return {undefined}
   */
  start : function() {
    var pm = this.kag.getStack("call");
    var auto_next = pm.auto_next;
    this.kag.ftag.nextOrderWithIndex(pm.index, pm.storage, undefined, undefined, auto_next);
    this.kag.popStack("call");
  }
};
tyrano.plugin.kag.tag.macro = {
  vital : ["name"],
  pm : {
    name : ""
  },
  /**
   * @param {Function} ui
   * @return {undefined}
   */
  start : function(ui) {
    var idx = this.kag.ftag.current_order_index;
    var storage = this.kag.stat.current_scenario;
    this.kag.stat.map_macro[ui.name] = {
      "storage" : storage,
      "index" : idx
    };
    /** @type {boolean} */
    this.kag.tmp.checking_macro = true;
    /** @type {number} */
    var i = 0;
    for (;i < 2E3;i++) {
      var r = this.kag.ftag.nextOrderWithTag({
        "endmacro" : ""
      });
      if (r == true) {
        break;
      }
    }
    if (i > 1900) {
      this.kag.error("\u30de\u30af\u30ed\u304c\u9589\u3058\u3066\u3044\u307e\u305b\u3093");
    }
  }
};
tyrano.plugin.kag.tag.endmacro = {
  /**
   * @param {?} ui
   * @return {undefined}
   */
  start : function(ui) {
    if (this.kag.tmp.checking_macro == true) {
      /** @type {boolean} */
      this.kag.tmp.checking_macro = false;
      this.kag.ftag.nextOrder();
      return;
    }
    var pm = this.kag.getStack("macro");
    if (pm) {
      this.kag.ftag.nextOrderWithIndex(pm.index, pm.storage, true);
      this.kag.popStack("macro");
      this.kag.stat.mp = this.kag.getStack("macro");
    } else {
    }
  }
};
tyrano.plugin.kag.tag.erasemacro = {
  vital : ["name"],
  pm : {
    name : ""
  },
  /**
   * @param {Function} ui
   * @return {undefined}
   */
  start : function(ui) {
    delete this.kag.stat.map_macro[ui.name];
  }
};
tyrano.plugin.kag.tag.savesnap = {
  vital : ["title"],
  pm : {
    title : ""
  },
  /**
   * @param {Element} ui
   * @return {undefined}
   */
  start : function(ui) {
    this.kag.menu.snapSave(ui.title);
  }
};
tyrano.plugin.kag.tag.autosave = {
  vital : [],
  pm : {
    title : ""
  },
  /**
   * @param {Element} test
   * @return {undefined}
   */
  start : function(test) {
    var that = this;
    if (test.title == "") {
      test.title = this.kag.stat.current_message_str;
    }
    this.kag.menu.snapSave(test.title, function() {
      that.kag.menu.doSetAutoSave();
      that.kag.ftag.nextOrder();
    });
  }
};
tyrano.plugin.kag.tag.autoload = {
  vital : [],
  pm : {
    title : ""
  },
  /**
   * @param {?} ui
   * @return {undefined}
   */
  start : function(ui) {
    var game_data = $.getStorage(this.kag.config.projectID + "_tyrano_auto_save");
    this.kag.menu.loadAutoSave();
  }
};
tyrano.plugin.kag.tag.ignore = {
  vital : ["exp"],
  pm : {
    exp : ""
  },
  /**
   * @param {Array} scope
   * @return {undefined}
   */
  start : function(scope) {
    if (this.kag.embScript(scope.exp)) {
      /** @type {number} */
      var i = 0;
      for (;i < 2E3;i++) {
        var r = this.kag.ftag.nextOrderWithTag({
          "endignore" : ""
        });
        if (r == true) {
          break;
        }
      }
      if (i > 1900) {
        this.kag.error("ignore\u304c\u9589\u3058\u3066\u3044\u307e\u305b\u3093");
      }
    } else {
      this.kag.ftag.nextOrder();
    }
  }
};
tyrano.plugin.kag.tag.endignore = {
  /**
   * @return {undefined}
   */
  start : function() {
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.edit = {
  vital : ["name"],
  pm : {
    name : "",
    length : "",
    color : "black",
    left : "0",
    top : "0",
    size : "20",
    width : "200",
    height : "40",
    maxchars : "1000"
  },
  /**
   * @param {Object} opts
   * @return {undefined}
   */
  start : function(opts) {
    var $this = $("<input class='text_box form' name='" + opts.name + "' type='text' value='' />");
    $this.click(function() {
      $this.focus();
    });
    opts = $.minifyObject(opts);
    var props = {
      color : $.convertColor(opts.color),
      left : parseInt(opts.left),
      top : parseInt(opts.top),
      width : opts.width,
      height : opts.height,
      "font-size" : parseInt(opts.size)
    };
    $this.css(props);
    $this.css("position", "absolute");
    $this.attr("maxlength", opts.maxchars);
    this.kag.layer.getFreeLayer().append($this);
    this.kag.layer.getFreeLayer().show();
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.preload = {
  vital : ["storage"],
  pm : {
    storage : "",
    wait : "false"
  },
  /**
   * @param {Object} options
   * @return {undefined}
   */
  start : function(options) {
    var that = this;
    if (options.wait == "true") {
      this.kag.layer.hideEventLayer();
    }
    var codeSegments = options.storage;
    if (typeof codeSegments == "object" && codeSegments.length > 0) {
      /** @type {number} */
      var count = 0;
      /** @type {number} */
      var i = 0;
      for (;i < codeSegments.length;i++) {
        that.kag.preload(codeSegments[i], function() {
          count++;
          if (codeSegments.length == count) {
            if (options.wait == "true") {
              that.kag.layer.showEventLayer();
            }
            that.kag.ftag.nextOrder();
          }
        });
      }
    } else {
      this.kag.preload(options.storage, function() {
        if (options.wait == "true") {
          that.kag.layer.showEventLayer();
        }
        that.kag.ftag.nextOrder();
      });
    }
  }
};
tyrano.plugin.kag.tag.clearfix = {
  pm : {
    name : ""
  },
  /**
   * @param {Function} d
   * @return {undefined}
   */
  start : function(d) {
    if (d.name != "") {
      $(".fixlayer." + d.name).remove();
    } else {
      $(".fixlayer").remove();
    }
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.commit = {
  /**
   * @return {undefined}
   */
  start : function() {
    var that = this;
    this.kag.layer.getFreeLayer().find(".form").each(function() {
      var label = $(this).attr("name");
      var expected = $(this).val();
      /** @type {string} */
      var r20 = label + " = '" + expected + "'";
      that.kag.evalScript(r20);
      that.kag.ftag.nextOrder();
    });
  }
};
tyrano.plugin.kag.tag.cursor = {
  vital : ["storage"],
  pm : {
    storage : "default"
  },
  /**
   * @param {Object} from
   * @return {undefined}
   */
  start : function(from) {
    this.kag.setCursor(from.storage);
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.screen_full = {
  vital : [],
  pm : {},
  /**
   * @param {?} ui
   * @return {undefined}
   */
  start : function(ui) {
    this.kag.menu.screenFull();
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.sleepgame = {
  vital : [],
  pm : {
    storage : "",
    target : ""
  },
  /**
   * @param {?} pm
   * @return {undefined}
   */
  start : function(pm) {
    var that = this;
    var r20 = this.kag.stat.current_message_str;
    this.kag.menu.snapSave(r20, function() {
      that.kag.menu.setGameSleep();
      that.kag.ftag.startTag("jump", pm);
    }, false);
  }
};
tyrano.plugin.kag.tag.awakegame = {
  vital : [],
  pm : {},
  /**
   * @param {?} ui
   * @return {undefined}
   */
  start : function(ui) {
    var that = this;
    if (this.kag.tmp.sleep_game == null) {
      this.kag.ftag.nextOrder();
    } else {
      var item = this.kag.tmp.sleep_game;
      item.stat.f = this.kag.stat.f;
      this.kag.menu.loadGameData($.extend(true, {}, item));
      /** @type {null} */
      this.kag.tmp.sleep_game = null;
    }
  }
};
tyrano.plugin.kag.tag.breakgame = {
  vital : [],
  pm : {},
  /**
   * @param {?} ui
   * @return {undefined}
   */
  start : function(ui) {
    var that = this;
    /** @type {null} */
    this.kag.tmp.sleep_game = null;
    this.kag.ftag.nextOrder();
  }
};
tyrano.plugin.kag.tag.dialog = {
  vital : [],
  pm : {
    name : "tf.dialog_value",
    type : "alert",
    text : "",
    storage : "",
    target : "",
    storage_cancel : "",
    target_cancel : "",
    label_ok : "OK",
    label_cancel : "Cancel"
  },
  /**
   * @param {Object} config
   * @return {undefined}
   */
  start : function(config) {
    var that = this;
    if (config.type == "confirm") {
      $.confirm(config.text, function() {
        that.finish(config);
      }, function() {
        config.storage = config.storage_cancel;
        config.target = config.target_cancel;
        that.finish(config);
      });
    } else {
      if (config.type == "input") {
        alertify.set({
          buttonFocus : "none",
          labels : {
            ok : config.label_ok,
            cancel : config.label_cancel
          }
        });
        alertify.prompt(config.text, function(dataAndEvents, $p3) {
          if (dataAndEvents) {
            var label = config.name;
            /** @type {string} */
            var err = $p3;
            /** @type {string} */
            var r20 = label + " = '" + err + "'";
            that.kag.evalScript(r20);
          } else {
            config.storage = config.storage_cancel;
            config.target = config.target_cancel;
          }
          that.finish(config);
        });
      } else {
        $.alert(config.text, function() {
          that.finish(config);
        });
      }
    }
  },
  /**
   * @param {Object} data
   * @return {undefined}
   */
  finish : function(data) {
    if (data.storage != "" || data.target != "") {
      this.kag.ftag.startTag("jump", data);
    } else {
      this.kag.ftag.nextOrder();
    }
  }
};
